SCREEN 9
'4-1B
LOCATE 10, 1
PRINT "       IN EULER APPROXIMATION THE VERHULST DYNAMICS, (4.1.7),"
PRINT ""
PRINT "                        DY/DT = R * Y * (1-Y)"
PRINT ""
PRINT "         IS THE SAME AS THE LOGISTIC-MAP DYNAMICS, (4.1.6),"
PRINT ""
PRINT "                      X(T+DT) = C * X(T)*(1-X(T))"
PRINT ""
PRINT "      IF C = (1+R*DT), AND X = Y/A, FOR SOME CONSTANT A; SEE THINK 4.1C"
PRINT ""

1 : IF INKEY$ = "" THEN GOTO 1
CLS
LOCATE 10, 1: PRINT "  THE NEXT FACT TO NOTE IS THAT THE GENERAL SOLUTION OF"
PRINT ""
PRINT "    THE NONLINEAR VERHULST EQUATION CAN BE OBTAIN WITHOUT MUCH DIFFICULTY"
PRINT ""
PRINT "     THE SOLUTION IS:       Y(T) = Y(0)/[Y(0) + (1 - Y(0)*EXP(-R*T))]"
PRINT
2 : IF INKEY$ = "" THEN GOTO 2
CLS
LOCATE 9, 7: PRINT " THE FOLLOWING WILL SHOW X(T) VS T, WHICH FOR SMALL VALUES OF DT"
LOCATE 11, 10: PRINT " IS A GOOD APPROXIMATION FOR THE CONTINUOUS VERHULST DYNAMICS "
LOCATE 13, 10: PRINT "  IF DT IS INCREASED, THE EULER DYNAMICS CEASES TO BE A GOOD"
LOCATE 15, 7:  PRINT "REPRESENTATION OF THE VERHULST DYNAMICS, AND BECOMES LOGISTIC-LIKE"
LOCATE 17, 15: PRINT "  TO INCREASE/DECREASE DT, <I>/<D>;    TO END, <X>"
LOCATE 19, 15: PRINT "THE DYNAMICS WILL BE INITIATED AT A SMALL POPULATION"
DBL = 9: MAG = 13: GRN = 10
GX = 20: GY = 300
AB: : IF INKEY$ = "" THEN GOTO AB
   CLS
   DT = 1.7  '**** ADJUST INITIAL DT

B: FOR L = 1 TO 10000: NEXT L  '** A DELAY TO OBSERVE GRAPHICS
   LINE (GX, GY)-(600, GY), DBL
   LINE (GX, 80)-(GX, GY), DBL
   L1 = 15
   LINE (65, L1)-(210, L1), GRN: LINE (230, L1)-(385, L1), MAG
   OY = Y
   OX = X
   MX = 15: MY = 200
   R = 1   '**** NO LOSS IN GENERALITY
   Y0 = .01
   CT = 0
   SCALE = R * DT / (1 + R * DT) '*** SCALING BETWEEN X AND Y
   X0 = Y0 * SCALE
   X = X0
   OX = X
   GOSUB E

A: '**** EULER APPROXIMATION
   C = 1 + DT * R
   CT = CT + 1
   T = DT * CT
   X = C * X * (1 - X)
   '*** X = [R*DT/(1+ R*DT)]* Y  = SCALE * Y
   XY = (1 + DT * R) / (R * DT) '*** INVERSE SCALE
   LINE (GX + MX * T, GY - MY * XY * X)-(GX + MX * (T - DT), GY - MY * XY * OX), MAG
   OX = X
   IF MX * T > 580 THEN OX = X
   IF MX * T > 580 THEN GOTO B '****
   IF CT = 0 THEN CLS
   IF CT = 0 THEN GOTO B
    
     A$ = INKEY$
     DELTA = .1  '*** ADJUST FOR MORE DETAILS
     IF A$ = "I" THEN DT = DT + DELTA
     IF A$ = "D" THEN DT = DT - DELTA
     IF A$ = "X" THEN END
     IF DT <= 0 THEN DT = DELTA

C:   LOCATE 1, 10: PRINT "VERHULST R = "; R; ",   LOGISTIC C ="; C; ",    DT= "; DT; "  "
     IF C < 2.5 THEN GOTO D
     IF C > 3.1 THEN GOTO D
     LOCATE 4, 5: PRINT "NOTE THE CHANGE IN THE LOGISTIC DYNAMICS AS C APPROACHES"
     LOCATE 5, 10: PRINT " THE FIRST BIFURCATION POINT, C = 3"
     
D:   IF C > 3.95 THEN C = 3.9
     IF C >= 3.9 THEN SOUND 500, 5
     IF C >= 3.9 THEN LOCATE 10, 30: PRINT "****** DECREASE DT ******"
    
   
GOTO A

E: CLS
   LOCATE 3, 20: PRINT "  TO INCREASE/DECREASE DT, <I>/<D>;  TO END, <X>"
   LINE (GX, GY)-(600, GY), DBL
   LINE (GX, 80)-(GX, GY), DBL
   L1 = 15
   LINE (65, L1)-(210, L1), GRN: LINE (230, L1)-(385, L1), MAG
  
   '*** EXACT SOLUTION GRAPHICS
   OY = Y0
   FOR Q = 0 TO 1000
   DS = 580 / (1000 * MX)
   S = Q * DS
   Y = Y0 / (Y0 + (1 - Y0) * EXP(-R * S))'*** EXACT MATH SOLUTION
    LINE (GX + MX * S, GY - MY * Y)-(GX + MX * (S - DS), GY - MY * OY), GRN
    OY = Y
    NEXT Q

  RETURN


