  SCREEN 9
  '4-2A
  PRINT "       THIS GIVES THE DISPLACEMENT VERSUS TIME FOR A HARMONIC OSCILLATOR"
  PRINT "  WHERE WE ARE USING THE EULER APPROXIMATION TO SOLVE THE DIFFERENTIAL EQUATIONS"
  PRINT "          "
  PRINT " LET'S USE THIS EXAMPLE TO DISCOVER SOMETHING ABOUT THE EULER APPROXIMATION"
    
AA: X = 1 + RND '** INITIAL CONDITIONS
   Y = 1 + RND
   F2 = 5 * RND
   F = SQR(F2) '***ANGULAR FREQUENCY
   DT = .003
   CT = 0
   TT = 0

B: LINE (10, 200)-(600, 200), 12
   LINE (10, 80)-(10, 320), 12
   IF TT = 1 THEN LOCATE 2, 10: PRINT "    IT LOOKS PRETTY SIMPLE, AND BORING - BUT... LOOK CLOSELY!"
   IF TT < 2 THEN GOTO A

B1: LOCATE 2, 10: PRINT " SEE ANYTHING CHANGING?    LET'S TRY SOMETHING NEW.             "
   PRINT "                       PRESENTLY THE VALUE OF DT = "; DT
   LINE (10, 65)-(600, 65), 14
   INPUT "   TRY A SLIGHTLY LARGER VALUE OF DT (SAY, 2*DT ) ="; DT
   
   CLS
   LINE (10, 65)-(600, 65), 14
   LINE (10, 200)-(600, 200), 12
   LINE (10, 80)-(10, 320), 12

A: CT = CT + 1
   T = CT * DT
   FOR K = 1 TO 10 * DT: NEXT

'MU = .0001 '*** EXPLORE THE STABILIZING INFLUENCE OF DAMPING

AB:  '*** HERE  ARE THE EQUATIONS OF MOTION IN EULER APPROXIMATION
  NX = X + DT * Y
  NY = Y - DT * F * X - MU * Y
  '*******  THAT'S ALL!
  
  Y = NY:  X = NX
 
  MX = 20
  LINE (10 + MX * T, 200 - 50 * X)-(10 + MX * OT, 200 - 50 * OX), 11
 
  OX = X   '** SAVES THE OLD VALUES OF X AND T FOR THE LINE GRAPHICS
  OT = T
 
  IF MX * T < 600 THEN GOTO A
 
  CT = 0
  OT = 0
  IF TT = 3 THEN GOTO Z2
  TT = TT + 1
  IF TT < 2 THEN CLS
  IF TT > 2 THEN GOSUB Z1
  IF TT < 3 THEN GOTO B
  GOTO A
  
Z1: LOCATE 8, 10:
    BEEP
    PRINT "    NOTICE THE MORE RAPIDLY INCREASING AMPLITUDE WHEN LARGER DT IS USED ?"
    PRINT ""
    PRINT "  BUT THE HARMONIC OSCILLATOR HAS A *CONSTANT* AMPLITUDE OF OSCILLATION !!"
    PRINT ""
    PRINT "           SO THE EULER APPROXIMATION CAN BE AN UNSTABLE METHOD"
    PRINT "  FOR ORDINARY DIFFERENTIAL SYSTEMS THAT ARE HIGHER THAN FIRST ORDER"
    PRINT ""
    PRINT "            TO SEE THIS MORE CLEARLY, USE A LARGER VALUE OF DT"
    PRINT ""
    INPUT "                    WHAT LARGER VALUE OF DT "; DT
    CLS
   
    LINE (1, 200)-(600, 200), 12
    LINE (1, 80)-(1, 320), 12
   RETURN

Z2: PRINT "                  THE INSTABILITY SHOULD BE QUITE CLEAR BY NOW"
    PRINT ""
    PRINT "                           TO CONTINUE STRIKE ANY KEY"
Z3: IF INKEY$ = "" THEN GOTO Z3
    CLS
    LOCATE 8, 1
    PRINT "       TO OBTAIN AN APPROXIMATE SOLUTION OF A DIFFERENTIAL EQUATION"
    PRINT ""
    PRINT "            THAT IS NOT UNSTABLE, READ ABOUT THE FOURTH-ORDER"
    PRINT ""
    PRINT "   RUNGE-KUTTA APPROXIMATION METHOD, WHICH WE WILL USE MOSTLY FROM NOW ON"
    PRINT ""
    PRINT " THE EXCEPTION IS WHEN THERE IS DAMPING, AND WE ONLY NEED A ROUGH UNDERSTANDING"; ""
    


