   '4-3A
    SCREEN 9
    LOCATE 5, 1
    PRINT "              THE UNDAMPED NONLINEAR DUFFING OSCILLATOR"
    PRINT ""
    PRINT "           DX(1)/DT = X(2)  ;  DX(2)/DT = - X(1) - A X(1)^3"
    PRINT ""
    PRINT "          USING THE FOURTH ORDER RUNGE-KUTTA ITERATION METHOD"
    
    N = 2: ' THE NUMBER OF FIRST-ORDER EQUATIONS
    DIM X(N), OX(N), Y(N), K(4, N)
   
    '***** COLOR SELECTIONS
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
   
    MX = 80: MY = .83 * MX: ' GRAPHIC MAGNIFICATION
    PRINT ""
    INPUT "             SELECT THE SIZE OF THE TIME STEP (E.G., .05)"; DT
   
    GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM

A: LOCATE 3, 30: PRINT "  NONLINEAR A ="; A; "           "
  
  ' *** THE INITIAL CONDITIONS ARE PRESENTLY FIXED AT X(1) = 0 X(2) =2
    X(1) = 0
    X(2) = 2
    CT = 0

C: ' ******** FOURTH ORDER RUNGE-KUTTA ROUTINE *************
     CT = CT + 1: ' USED NEAR I
    
     '*** Y(I) IS A DUMMY VARIABLE WHICH IS CHANGED AT EACH OF THE FOUR ORDERS
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS

D:   J = J + 1
     A$ = INKEY$
     IF A$ = "C" THEN GOSUB B  '*** CLEARS THE SCREEN AND CONTINUES
     IF A$ = "I" THEN A = A + .04  '*** INCREASING THE NONLINEARITY
     IF A$ = "I" THEN GOTO A
     IF A$ = "D" THEN A = A - .04
     IF A < 0 THEN SOUND 1000, 2     '######
     IF A < 0 THEN A = 0             '######
     IF A$ = "D" THEN GOTO A
     IF A$ = "X" THEN END
 
     '**** THE N DYNAMIC FUNCTIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-Y(1) - A * Y(1) ^ 3)
     '************************************
     
    ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
   
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I: ' GRAPHIC LINE STARTS AFTER SECOND ITERATION
    CL = LBL
    IF A < 0 THEN CL = YEL
    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), CL

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I: ' SAVES THE LAST X(I) FOR GRAPHIC LINE
    GOTO C

 
B:   ' ********** COORDINATE SYSTEM GRAPHICS ****************
     CLS
     PRINT "        THE UNDAMPED DUFFING OSCILLATOR, USING THE RUNGE-KUTTA METHOD "
     PRINT "                CLEAR SCREEN, <C>;  INCREASE/DECREASE A, <I>/<D>"
     LOCATE 3, 30: PRINT "  NONLINEAR A ="; A; "           "
     NX = 300 / MX: NY = 190 / MY: '*** NUMBER OF `TICKS' ON X AND Y AXES
    
     LINE (20, 200)-(620, 200), DBL '*** AXES
     LINE (320, 20)-(320, 380), DBL
    
     FOR I = 1 TO NX  '*** PUTS NX `TICKS' ON THE X AXIS
     FOR J = 1 TO 4
     PSET (320 + MX * I, 200 - J), DBL
     PSET (320 - MX * I, 200 - J), DBL
     NEXT J
     NEXT I
    
     FOR I = 1 TO NY  '*** `TICKS' ON Y AXIS
     FOR J = 1 TO 3
     PSET (320 + J, 200 - MY * I), DBL
     PSET (320 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN


