   
   SCREEN 9
    '4-3C
    LOCATE 5, 1
    PRINT "               HERE WE STUDY THE RELATIONSHIP BETWEEN THE "
    PRINT ""
    PRINT "      PERIOD AND AMPLITUDE OF THE UNDAMPED NONLINEAR DUFFING OSCILLATOR "
    PRINT ""
    PRINT "              DX/DT = Y ; DY/DT = -X - A * X^3   (A >0)"
    PRINT ""
    PRINT "         THE PERIOD CAN ALSO BE STUDIED AS A FUNCTION OF THE"
    PRINT ""
    PRINT "       NONLINEAR CONSTANT, A, WHERE LARGE A IS A 'STIFF' SPRING"
AO: IF INKEY$ = "" THEN GOTO AO
    N = 2: ' THE NUMBER OF FIRST-ORDER EQUATIONS
    DIM X(N), OX(N), Y(N), K(4, N)
   
    '***** COLOR SELECTIONS
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
   
    MX = 20: MY = .9 * MX: ' GRAPHIC MAGNIFICATION
    PRINT ""
   ' INPUT "                THE SIZE OF THE TIME STEP"; DT
    DT = .02
     PRINT ""
     INPUT "     BEGIN WITH A SMALL NONLINEAR CONSTANT A (E.G.,.01), A ="; A
     XO = 0
     GOTO AA

A1: 'FOR NEW NONLINEAR CONSTANT
     CLS
     LOCATE 10, 1
     PRINT "           THE PRESENT VALUE OF THE NONLINEAR CONSTANT  A ="; A
     PRINT ""
     INPUT "             INCREASE IT BY SMALL AMOUNTS, SUCH AS .02, A="; A
     XO = 0

AA: ' THE INITIAL AMPLITUDE IS MADE PROGRESSIVELY LARGER
    CT = 0
    XO = XO + 1   '**** INITIAL AMPLITUDED INCREASED
    X(1) = XO
    X(2) = 0
    CIRCLE (320 + MX * X(1), 200 - MY * X(2)), 3, RED
   
    '*** FOR SPECIFIC OR RANDOM INITIAL CONDITIONS USE PARTS OF THIS
    'FOR I = 1 TO N
    'PRINT ""
    'PRINT "    X("; I; ")  =",
    'INPUT X(I)
    'X(I) = 5 * RND
    'NEXT I

A:  CLS
    GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM

    
C: ' ******** FOURTH ORDER RUNGE-KUTTA ROUTINE *************
     CT = CT + 1: ' USED NEAR I
    
     '*** Y(I) IS A DUMMY VARIABLE WHICH IS CHANGED AT EACH OF THE FOUR ORDERS
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     A$ = INKEY$
     IF A$ = "I" THEN GOTO AA '** INCREASES THE AMPLITUDE
     IF A$ = "N" THEN GOTO A1 '** TO CHANGE THE CONSTANT A
     IF A$ = "C" THEN GOSUB B '** TO CLEAR THE SCREEN AND CONTINUE
     IF A$ = "X" THEN END
    
     '**** THE N DYNAMIC FUNCTIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-Y(1) - A * Y(1) ^ 3)
     '*********************************
     
    ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I: ' GRAPHIC LINE STARTS AFTER SECOND ITERATION
    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), LBL
   
    '***** DETERMINING THE PERIOD
    IF X(1) < 0 THEN GOTO I    '*** INTERESTED WHEN X(1)>0 AND X(2) = 0
    IF X(2) * OX(2) > 0 THEN GOTO I '*** SINCE X(2) HASN'T CHANGED SIGN
    P = T - LT '*** THE APPROXIMATE PERIOD
    LT = T   '*** RECORDING THE APPROXIMATE TIME OF CROSSING
    PI = 3.14159265#
    TP = 2 * PI / (1 + (3 * A * X(1) ^ 2 / 8))
    LOCATE 3, 10: PRINT " THE PERIOD IS ="; P; ", THE AMPLITUDE IS = "; X(1)
    LOCATE 4, 10: PRINT " THE APPROXIMATE THEORETICAL PERIOD IS P(X(1))= "; TP
    '*******
I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I: ' SAVES THE LAST X(I) FOR GRAPHIC LINE
    GOTO C


    
B:   ' ********** COORDINATE SYSTEM GRAPHICS ****************
     CLS
     LOCATE 1, 20:  PRINT " TO INCREASE THE INITIAL AMPLITUDE, <I> "
     LOCATE 2, 20:  PRINT " TO CHANGE THE NONLINEAR CONSTANT A, <N>"
     LOCATE 3, 10: PRINT " THE PERIOD IS ="; P; ", THE AMPLITUDE IS = "; X(1)
     LOCATE 4, 10: PRINT " THE APPROXIMATE THEORETICAL PERIOD IS P(X(1))= "; TP
    
     NX = 300 / MX: NY = 190 / MY: '*** NUMBER OF `TICKS' ON X AND Y AXES
    
     LINE (20, 200)-(620, 200), DBL '*** AXES
     LINE (320, 20)-(320, 380), DBL
    
     FOR I = 1 TO NX  '*** PUTS NX `TICKS' ON THE X AXIS
     FOR J = 1 TO 4
     PSET (320 + MX * I, 200 - J), DBL
     PSET (320 - MX * I, 200 - J), DBL
     NEXT J
     NEXT I
    
     FOR I = 1 TO NY  '*** `TICKS' ON Y AXIS
     FOR J = 1 TO 3
     PSET (320 + J, 200 - MY * I), DBL
     PSET (320 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN



