   '4-3D
    SCREEN 9
    LOCATE 5, 1
    PRINT "              THE GENERAL NONLINEAR DUFFING OSCILLATOR"
    PRINT ""
    PRINT "          USING THE FOURTH ORDER RUNGE-KUTTA ITERATION METHOD"
    
    N = 2: ' THE NUMBER OF FIRST-ORDER EQUATIONS
    DIM X(N), OX(N), Y(N), K(4, N)
   
    '***** COLOR SELECTIONS
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
   
    MX = 20: MY = .83 * MX: ' GRAPHIC MAGNIFICATION
    PRINT ""
    INPUT "                 THE SIZE OF THE TIME STEP (E.G., .05)"; DT
   
AA: PRINT " THE INITIAL CONDITIONS"  '*** PRESENTLY SET AT RANDOM
    CT = 0
    FOR I = 1 TO N
    PRINT ""
    'PRINT "    X("; I; ")  =",
    'INPUT X(I)
    X(I) = 5 * RND
    NEXT I

A:  GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM
    
C: '******** FOURTH ORDER RUNGE-KUTTA ROUTINE **********
     CT = CT + 1: ' USED NEAR I
    
     '*** Y(I) IS A DUMMY VARIABLE WHICH IS CHANGED AT EACH OF THE FOUR ORDERS
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
      A$ = INKEY$
     IF A$ = "N" THEN GOTO AA
     IF A$ = "C" THEN GOSUB B
     IF A$ = "I" THEN A = A + .1
     IF A$ = "D" THEN A = A - .1
     IF A < 0 THEN SOUND 1000, 2
     IF A < 0 THEN A = 0
     IF A$ = "H" THEN MU = MU + .01
     IF A$ = "L" THEN MU = MU - .01
     IF MU < 0 THEN SOUND 1200, 2
     IF MU < 0 THEN MU = 0
     IF A$ = "X" THEN END
     IF A$ = "" THEN GOTO D1
     LOCATE 3, 10: PRINT "INCREASE/DECREASE MU, <H>/<L>;      NONLINEAR A ="; A; ", MU ="; MU; "      "

D1:     '**** THE N DYNAMIC FUNCTIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-MU * Y(2) - Y(1) - A * Y(1) ^ 3)
     '************************************
     
    ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
   
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I: ' GRAPHIC LINE STARTS AFTER SECOND ITERATION
    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), LBL

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I: ' SAVES THE LAST X(I) FOR GRAPHIC LINE
    GOTO C
    
B: ' ********** COORDINATE SYSTEM GRAPHICS ***********
     CLS
     PRINT "             THE DUFFING OSCILLATOR, USING THE RUNGE-KUTTA METHOD "
     PRINT "  CLEAR SCREEN, <C>; NEW INITIAL CONDITION, <N>; INCREASE/DECREASE A, <I>/<D>"
     LOCATE 3, 10: PRINT "INCREASE/DECREASE MU, <H>/<L>;      NONLINEAR A ="; A; ", MU ="; MU; "      "
     NX = 300 / MX: NY = 190 / MY: '*** NUMBER OF `TICKS' ON X AND Y AXES
    
     LINE (20, 200)-(620, 200), DBL '*** AXES
     LINE (320, 20)-(320, 380), DBL
    
     FOR I = 1 TO NX  '*** PUTS NX `TICKS' ON THE X AXIS
     FOR J = 1 TO 4
     PSET (320 + MX * I, 200 - J), DBL
     PSET (320 - MX * I, 200 - J), DBL
     NEXT J
     NEXT I
    
     FOR I = 1 TO NY  '*** `TICKS' ON Y AXIS
     FOR J = 1 TO 3
     PSET (320 + J, 200 - MY * I), DBL
     PSET (320 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN



