   '4-4A
    SCREEN 9
    
    LOCATE 1, 20: PRINT "  THE DYNAMICS IN A DOUBLE-WELL POTENTIAL "
    A = .04  '****** NONLINEAR CONSTANT

   'MU = .1  '####### TO SEE THE INFLUENCE OF DAMPING

    LOCATE 3, 20: PRINT "        DX/DT = Y ;    DY/DT = -MU Y + X - A X^3   "
    LOCATE 4, 25: PRINT "    A ="; A; "     MU ="; MU; " "
    N = 2: ' THE NUMBER OF FIRST-ORDER EQUATIONS
    DIM X(N), OX(N), Y(N), K(4, N)
   
    '***** COLOR SELECTIONS
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
    MX = 20: MY = .83 * MX: ' GRAPHIC MAGNIFICATION
    DT = .05

AB: '**** THESE ARE VERY SELECTIVE ORBITS
   
    GOSUB B
    Z = Z + 1
    CT = 0
    ON Z GOTO A1, A2, A3, A4, A5, A6, A7, A8, A9 '*** SENT SEQUENTIALLY
     
A1: CL = YEL
    X(1) = .1   '*** POSITIVELY NEAR ORIGIN
    X(2) = 0
    SOUND 500, 2
    IF MU = 0 THEN LOCATE 23, 15: PRINT "FIRST, ORBITS FROM THE SADDLE POINT AT THE ORIGIN"
    SLEEP 4
    GOTO AA
    
A2: CL = YEL
    X(1) = -.1   '*** NEGATIVELY NEAR ORIGIN
    X(2) = 0
    GOTO AA
 
A3: X(1) = 0   '*** ON THE POSITIVE Y AXIS
    X(2) = 2
    CL = RED
    SOUND 600, 2  '*** INDICATES THE CHANGE IN DYNAMIC CHARACTER
    IF MU = 0 THEN LOCATE 23, 15: PRINT " NEXT, THE 'EXTERIOR ORBITS', CIRCLING All FIXED POINTS"
    SLEEP 4
    GOTO AA

A4: X(1) = 0  '*** FURTHER UP THE Y AXIS
    X(2) = 4
    CL = RED
    GOTO AA

A5: IF MU > 0 THEN LOCATE 23, 10: PRINT " NOTICE THAT THE TWO RED ORBITS TEND TO DIFFERENT FIXED POINTS"
    IF MU > O THEN SLEEP 6
    LOCATE 23, 10: PRINT "                                                                     "
    X(1) = 2
    X(2) = 0
    CL = LBL
    SOUND 700, 2  '*** CHANGE IN CHARACTER
    IF MU = 0 THEN LOCATE 23, 15: PRINT "TWO SETS OF ELLIPTIC ORBITS, ABOUT TWO FIXED POINTS       "
    SLEEP 4
    GOTO AA

A6: X(1) = (1 / SQR(A)) + .5   '*** CLOSER TO THE POSITIVE FIXED POINT
    X(2) = 0
    CL = LBL
    GOTO AA

A7: X(1) = -2  '*** NOW ON THE NEGATIVE SIDE
    X(2) = 0
    CL = MAG
    GOTO AA

A8: X(1) = -(1 / SQR(A)) + .5
    X(2) = 0
    CL = MAG
    GOTO AA


A9: SLEEP 4
    SOUND 1200, 3
    IF MU > 0 THEN LOCATE 22, 10: PRINT "      WHERE ARE THE TWO ORBITS THAT TEND TO THE ORIGIN ??"
    LOCATE 23, 10: PRINT "                 ***** TO REPEAT, <R> *****                     "
    ZZ = 0

    SLEEP 10
    IF INKEY$ = "R" THEN ZZ = 1

    IF ZZ = 1 THEN CLS
    IF ZZ = 1 THEN Z = 0
    IF ZZ = 1 THEN GOTO AB
                             
    SOUND 1300, 5
    IF MU = 0 THEN LOCATE 23, 15: PRINT "NOW STUDY THE INFLUENCE OF DAMPING; SEE EXPLORE 4.4B          "
    IF MU = 0 THEN END
    IF MU > 0 THEN END

AA: GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM

C: '******** FOURTH ORDER RUNGE-KUTTA ROUTINE *************
     CT = CT + 1
     IF CT > (300 + 1000 * MU) THEN GOTO AB'*** THE DURATION OF EACH EXAMPLE
     
     '*** Y(I) IS A DUMMY VARIABLE WHICH IS CHANGED AT EACH OF THE FOUR ORDERS
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     A$ = INKEY$
     IF A$ = "N" THEN GOTO AB
     IF A$ = "C" THEN CLS
     IF A$ = "C" THEN GOTO AB
    
    '**** THE N DYNAMIC FUNCTIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-MU * Y(2) + Y(1) - A * Y(1) ^ 3)
     '*********************************
     
    ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D

F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D

G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D

H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I
    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), CL

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
    GOTO C


B:  ' ********** COORDINATE SYSTEM GRAPHICS ****************
     
    '*** THE FIXED POINTS
     CIRCLE (320, 200), 3, YEL
     CIRCLE (320 + MX * (1 / SQR(A)), 200), 3, LBL
     CIRCLE (320 - MX * (1 / SQR(A)), 200), 3, MAG
     '*********************
     LINE (20, 200)-(620, 200), DBL '*** AXES
     LINE (320, 20)-(320, 380), DBL
     RETURN



