   '4-4B
    SCREEN 9
    A = .04 ' *** NONLINEAR CONSTANT
    MU = .05' *** DAMPING
    LOCATE 3, 10: PRINT "  DX/DT = Y ;    DY/DT = X - A X^3 - MU Y   "
    LOCATE 5, 20: PRINT "    A ="; A; " , MU ="; MU; " "
    PRINT ""
    PRINT "           DAMPED DYNAMICS IN A DOUBLE-WELL POTENTIAL "
    PRINT "   "
    PRINT "       ONE METHOD TO STUDY OF THE TWO BASINS OF ATTRACTION IS"
    PRINT ""
    PRINT "         TO FOLLOW THE DYNAMICS OF INITIAL STATES AT X = 0"
    PRINT ""
    PRINT "  BUT PROGRESSIVELY LARGER VALUES OF X(2).  WHEN THESE ORBITS CHANGE"
    PRINT ""
    PRINT "  ATTRACTORS, THE INITIAL POINTS LIE IN DIFFERENT BASINS OF ATTRACTION "
    PRINT ""
    PRINT ""
    PRINT "      BUT THERE MUST BE A BOUNDARY BETWEEN THESE TWO BASINS"
   
    PRINT "       WHERE DOES THAT BOUNDARY CURVE GO IN THE PHASE SPACE ?"
   
    N = 2
    DIM X(N), OX(N), Y(N), K(4, N)
    A$ = INKEY$
A1: IF INKEY$ = "" THEN GOTO A1
    '***** COLOR SELECTIONS
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
    MX = 30: MY = .83 * MX: ' GRAPHIC MAGNIFICATION
    DT = .04
  
A:  GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM
    OY = 0
       NN = 0: ORB = 0
AA: '*** THE INITIAL CONDITIONS ARE ALL AT X = 0, AND PROGRESSIVE VALUES OF Y
    CT = 0
    NN = NN + 1
    IF A$ = "U" THEN OY = OY + .5'*** REDUCE THE STEP SIZE TO DETERMINE THE BASINS
    IF A$ = "D" THEN OY = OY - .5
    X(1) = 0
    X(2) = OY
    IF A$ = "U" THEN ORB = ORB + 1 '*** COUNTING NUMBER OF ORBITS
    IF ORB = 10 THEN GOTO Z

    LOCATE 1, 1: PRINT "          THE PRESENT INITIAL CONDITION IS X(1) = 0, X(2) ="; X(2); "   "
    LOCATE 2, 1: PRINT "                 TO STEP UP/DOWN THE INITIAL VALUE OF X(2),  <U>/<D>"
    LOCATE 3, 20: PRINT "               TO CLEAR SCREEN, <C>"
C: ' ******** FOURTH ORDER RUNGE-KUTTA METHOD *************
     CT = CT + 1
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
     A$ = INKEY$
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     IF A$ = "U" THEN GOTO AA
     IF A$ = "D" THEN GOTO AA
     IF A$ = "C" THEN GOSUB B
    
     '**** THE N DYNAMIC FUNCTIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-MU * Y(2) + Y(1) - A * Y(1) ^ 3)
     '*********************************
     
    ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D

F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D

G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D

H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I
    IF NN > 5 THEN NN = 0
    CL = 9 + NN
    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), CL

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
     IF CT = 1000 THEN GOSUB J
 
    GOTO C
J:     SOUND 800, 1
       LOCATE 23, 30: PRINT "  SELECT <U> OR <D>"
       RETURN
B:   ' ********** COORDINATE SYSTEM GRAPHICS ****************
     CLS
    LOCATE 1, 1: PRINT "          THE PRESENT INITIAL CONDITION IS X(1) = 0, X(2) ="; X(2); "   "
    LOCATE 2, 1: PRINT "                 TO STEP UP/DOWN THE INITIAL VALUE OF X(2),  <U>/<D>"
    LOCATE 3, 20: PRINT "               TO CLEAR SCREEN, <C>"
    
     NX = 300 / MX: NY = 190 / MY: '*** NUMBER OF `TICKS' ON X AND Y AXES
     LINE (20, 200)-(620, 200), DBL '*** AXES
     LINE (320, 20)-(320, 380), DBL
    
     FOR I = 1 TO NX  '*** PUTS NX `TICKS' ON THE X AXIS
     FOR J = 1 TO 4
     PSET (320 + MX * I, 200 - J), DBL
     PSET (320 - MX * I, 200 - J), DBL
     NEXT J
     NEXT I
    
     FOR I = 1 TO NY  '*** `TICKS' ON Y AXIS
     FOR J = 1 TO 3
     PSET (320 + J, 200 - MY * I), DBL
     PSET (320 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN
                                                    
Z:    LOCATE 23, 10: PRINT "                 ***** TO REPEAT, <R> *****                     "
    ZZ = 0
    SLEEP 10
    IF INKEY$ = "R" THEN GOTO A

LOCATE 22, 15: PRINT "TRY DECREASING THE STEP SIZE ON OY; SEE FOLLOWING AA"
LOCATE 23, 15: PRINT "  LOCATE THE *TWO* ORBITS *INTO* THE SADDLE POINT"


