   '4-4C
    SCREEN 9
    LOCATE 5, 1
    PRINT "               DAMPED DYNAMICS IN A DOUBLE-WELL POTENTIAL "
    PRINT ""
    PRINT "      A `BACKWARD' METHOD OF DETERMININING THE BASINS OF ATTRACTION "
    PRINT ""
    PRINT "       THE INITIAL CONDITIONS CIRCLE THE TWO ATTRACTOR FIXED POINTS"
    PRINT "        "
    PRINT "             AND WE MAKE USE OF THE SYMMETRY OF THE EQUATIONS "
    PRINT ""
    PRINT "                   TO PLOT TWO SOLUTIONS AT ONE TIME "
    PRINT ""
    PRINT "                     BUT WE RUN THE TIME BACKWARDS !"
    N = 2
    DIM X(N), OX(N), Y(N), K(4, N)
1 : IF INKEY$ = "" THEN GOTO 1
    
    '***** COLOR SELECTIONS
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
    MX = 10: MY = .83 * MX: ' GRAPHIC MAGNIFICATION
    DT = -.05  '********* NOTICE THAT TIME RUNS BACKWARDS !!! **************
    A = .04
    MU = .1
    NN = 0
A:  GOSUB B: ' GRAPHICS
  
AA: '*** ONE INITIAL CONDITION CIRCLES THE FIXED POINT A (1/SQR(A), 0)
    CT = 0
    NN = NN + 1
    SOUND 300 + 20 * NN, 2
    IF NN = 16 THEN GOTO ZZ
    PI = 3.141529
   
    '**** THE INITIAL CONDITIONS OF THE 'BACKWARDS-TIME MOTION'
    '***** THIS CIRCLES THE POSITIVE-X FIXED POINT, AT A DISTANCE OF 0.5
    OX = (1 / SQR(A)) + .5 * COS(NN * PI / 8)
    OY = .5 * SIN(NN * PI / 8)
    '************************************************
   
    X(1) = OX
    X(2) = OY
   
    LOCATE 1, 15: PRINT "    ONE INITIAL CONDITION CIRCLES (1/SQR(A),0)"
    LOCATE 2, 15: PRINT "   IT IS AT X(1) ="; X(1); ",  X(2) ="; X(2); "                  "
    LOCATE 3, 25: PRINT " THE NUMBER OF ORBITS ="; 2 * NN
C: ' ******** FOURTH ORDER RUNGE-KUTTA METHOD *************
    CT = CT + 1
    FOR I = 1 TO N
    Y(I) = X(I)
    NEXT I
    A$ = INKEY$
   
    '**********************
    J = 0: ' INDEX FOR THE FOUR ORDERS
D:  J = J + 1
    IF X(1) > 10 THEN GOTO AA '***** TERMINATES THE RUN
    IF A$ = "N" THEN GOTO AA
    IF A$ = "C" THEN GOSUB B
    '**** THE N DYNAMIC FUNCTIONS ****
    K(J, 1) = DT * Y(2)
    K(J, 2) = DT * (-MU * Y(2) + Y(1) - A * Y(1) ^ 3)
    '*********************************
     
    ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D

F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D

G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D

H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
    IF CT = 1 THEN GOTO I
   
    '********** THE TWO ORBITS (WITH [+,-] MX AND MY) GRAPHED SIMULATIOUSLY
    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), 12
    LINE (320 - MX * X(1), 200 + MY * X(2))-(320 - MX * OX(1), 200 + MY * OX(2)), 14
    '***************************************************************

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
    GOTO C

   
B:  '*********** COORDINATE SYSTEM GRAPHICS ****************
    CLS
    NX = 300 / MX: NY = 190 / MY: '*** NUMBER OF `TICKS' ON X AND Y AXES
    LINE (20, 200)-(620, 200), DBL '*** AXES
    LINE (320, 20)-(320, 380), DBL
    
    FOR I = 1 TO NX
    FOR J = 1 TO 4
    PSET (320 + MX * I, 200 - J), DBL
    PSET (320 - MX * I, 200 - J), DBL
    NEXT J
    NEXT I
    
    FOR I = 1 TO NY  '*** `TICKS' ON Y AXIS
    FOR J = 1 TO 3
    PSET (320 + J, 200 - MY * I), DBL
    PSET (320 + J, 200 + MY * I), DBL
    NEXT J
    NEXT I
    RETURN

ZZ: LOCATE 23, 5: PRINT " A FEW OF THE INFINITE NUMBER OF ORBITS IN THE TWO BASINS OF ATTRACTION"


