
    '4-5A
    SCREEN 9
    RANDOMIZE TIMER
    LOCATE 5, 1
    PRINT "     THIS SHOWS THE DAMPED PENDULUM MOTION IN BOTH THE PHYSICAL SPACE  "
    PRINT ""
    PRINT "              AND IN THE 'THETA-WRAP-AROUND' PHASE SPACE "
    PRINT ""
    PRINT "     THE IDEA OF THIS SO-CALLED 'THETA-WRAP-AROUND' PHASE SPACE  "
    PRINT ""
    PRINT "     IS SIMPLY A WAY TO REPRESENT THE IMPORTANT FEATURES OF THE"
    PRINT ""
    PRINT "   DYNAMICS IN THE INFINITE PHASE SPACE IN A LIMITED GRAPHICAL REGION"
    PRINT ""
    PRINT ""
    PRINT "      TO ACCOMPLISH THIS, IF THETA >3*PI (PI=3.1415...), THEN SUBTRACT 6*PI,"
    PRINT ""
    PRINT "                  AND IF THETA < - 3*PI THEN ADD 6*PI"
    PRINT ""
    PRINT "          SOUNDS STRANGE, BUT YOU WILL SEE HOW NICELY IT WORKS; "; ""
AAA: IF INKEY$ = "" THEN GOTO AAA
    CLS
    LOCATE 5
    PRINT "                 THE DAMPED PENDULUM EQUATIONS ARE "
    PRINT ""
    PRINT "                 DX/DT = Y  ; DY/DT = - MU * Y - SIN(X) "
    PRINT ""
    PRINT "     X REPRESENTS THE ANGLE THETA, AND Y IS THE ANGULAR VELOCITY, DX/DT"
    PRINT ""
    PRINT "      RANDOM INITIAL VALUES OF DY/DT WILL BE SELECTED EACH TIME YOU <N>"
    N = 2
    DIM X(N), OX(N), Y(N), K(4, N)
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14

AA: PRINT ""
    PRINT ""
AF:    INPUT "           SELECT A DAMPING CONSTANT (E.G., MU < .1)"; MU
   

    'INPUT "          GRAPHICS MAGNIFICATION ="; M
    M = 30
    MX = M: MY = .73 * M
    DT = .03
   
   
K: '***** RANDOMIZED INITIAL CONDITIONS
    PI = 3.141529
    X(1) = 0 '**** THE INITIAL ANGLE IS TAKEN TO BE ZERO
    X(2) = 4 * (1.5 - 3 * RND) '*** YOU CAN REPLACE 4, AND SEE THE EFFECT
    CT = 0:
    
    GOSUB B: ' THE COORDINATE SYSTEM

C:      ' ******** ITERATION LOOP *************
     A$ = INKEY$
     IF A$ = "M" THEN GOTO AA: 'NEW MU
     IF A$ = "N" THEN GOTO K
     IF A$ = "X" THEN END
     CT = CT + 1
    
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
    
     '**** THE PENDULUM EQUATIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-MU * Y(2) - SIN(Y(1)))
     '*********************************
    
     ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:   T = T + .5 * DT
     FOR I = 1 TO N
     Y(I) = X(I) + K(1, I) / 2
     NEXT I
     GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I
   
    LINE (310 + MX * X(1), 200 - MY * X(2))-(310 + MX * OX(1), 200 - MY * OX(2)), YEL
   

  
  '***** GRAPHICS OF THE PENDULUM MOTION ****
    L = 50 '*** LENGTH OF THE PENDULUM
    PX = 500: PY = 80'*** WHERE THE PENDULUM IS HUNG
    ' *** THE OX(1) WITH "COLOR" 0 , ERASES THE LAST LOCATION
    LINE (PX, PY)-(PX + L * SIN(OX(1)), PY + L * COS(OX(1))), 0
    LINE (PX, PY)-(PX + L * SIN(X(1)), PY + L * COS(X(1))), LBL
    CIRCLE (PX + L * SIN(OX(1)), PY + L * COS(OX(1))), 2, 0
    CIRCLE (PX + L * SIN(X(1)), PY + L * COS(X(1))), 2, YEL
    
    '***** THE PHASE SPACE IS EXTENDED OVER 6*PI FOR THETA
    
    IF ABS(X(1)) < 3 * PI THEN GOTO I
    BEEP
    IF X(1) >= 3 * PI THEN X(1) = X(1) - 6 * PI
    IF X(1) <= -3 * PI THEN X(1) = X(1) + 6 * PI
    IF OX(1) <= -3 * PI THEN OX(1) = OX(1) + 6 * PI
    IF OX(1) >= 3 * PI THEN OX(1) = OX(1) - 6 * PI
    CT = 0
    GOSUB B

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
   
    GOTO C

B:   '**********  COORDINATE SYSTEM  *************
     CLS
     LOCATE 1, 5: PRINT " DAMPED PENDULUM DYNAMICS DISPLAYED WITHIN -3*PI < THETA < 3*PI"
     LOCATE 2, 5: PRINT " MU = "; MU; ", FOR NEW MU = <M>          "
     LOCATE 3, 5: PRINT " NEW INITIAL CONDITION, <N>;          EXIT =<X>"
     LINE (40, 41)-(260, 41), RED
     PI = 3.141529
     LINE (20, 200)-(600, 200), DBL
     LINE (310, 20)-(310, 360), DBL
     FOR I = 1 TO 3
     FOR J = 1 TO 4
     PSET (310 + MX * I * PI, 200 - J), DBL
     PSET (310 - MX * I * PI, 200 - J), DBL
     NEXT J
     NEXT I
     FOR J = 1 TO 4
     PSET (310, 400 - J), DBL
     NEXT J
     FOR I = 1 TO NY
     FOR J = 1 TO 3
     PSET (310 + J, 200 - MY * I), DBL
     PSET (310 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN


