
    '4-5B
    SCREEN 9
    RANDOMIZE TIMER
  
    N = 2
    DIM X(N), OX(N), Y(N), K(4, N)
A:  CLS
    LOCATE 5, 1
    PRINT "      *** A 'WRAP-AROUND' PHASE PORTRAIT OF A DAMPED PENDULUM ***"
    PRINT ""
    PRINT "               DX/DT = Y  ; DY/DT = - MU * Y - SIN(X) "
    PRINT ""
    PRINT "     X REPRESENTS THE ANGLE THETA, AND Y IS THE ANGULAR VELOCITY, DX/DT"
    PRINT ""
   
AF:    INPUT "           SELECT THE DAMPING CONSTANT MU (BEGIN WITH MU >.05)"; MU
    IF MU < .05 THEN SOUND 1200, 3
    IF MU < .05 THEN GOTO AF
AB: CLS
    DBL = 9: GRN = 10: LBL = 11: RED = 12
        MAG = 13: YEL = 14: '***** COLOR SELECTIONS
    'INPUT "          GRAPHICS MAGNIFICATION ="; M
    M = 30
    MX = M: MY = .73 * M
    DT = .03
    TT = 0: T = 0: CT = 0
    GOSUB B: ' THE COORDINATE SYSTEM
   
KK: '***** RANDOMIZED INITIAL CONDITIONS
    X(1) = -3 * PI
    Y0 = .5 * RND + .5 * TT
    CT = 0:
  
K:  CT = 0
    TT = TT + 1
    TS = TS + 1
    BEEP
    X(1) = -3 * PI
    X(2) = Y0 + 6 - .5 * TT'***  STEP-DOWN INITIAL CONDITIONS
    IF TT > 22 THEN GOTO J
    IF TS > 11 THEN TS = 0
    IF TS = 0 THEN GOTO KK

CC:  LOCATE 2, 10: PRINT "THE INITIAL STATE IS (X(1),X(2)) = (+/-) ("; X(1); ","; X(2); ")      "
    
C:      ' ******** ITERATION LOOP *************
    
     A$ = INKEY$
     IF A$ = "M" THEN GOTO A: 'NEW MU
     IF A$ = "X" THEN END
     CT = CT + 1
     IF CT > 1400 THEN GOTO K '*** LIMITS ASYMPTOTIC DYNAMICS
    
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     'KAPPA = .09
     '**** THE PENDULUM EQUATIONS ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-MU * Y(2) - SIN(Y(1)) - KAPPA * Y(1))
     '*********************************
    
     ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:   T = T + .5 * DT
     FOR I = 1 TO N
     Y(I) = X(I) + K(1, I) / 2
     NEXT I
     GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO I
   
    '***** THE PHASE SPACE IS EXTENDED OVER 6*PI FOR THETA
    IF X(1) >= 3 * PI THEN GOTO K
    '*****
              
    LINE (310 + MX * X(1), 200 - MY * X(2))-(310 + MX * OX(1), 200 - MY * OX(2)), GRN
    LINE (310 - MX * X(1), 200 + MY * X(2))-(310 - MX * OX(1), 200 + MY * OX(2)), RED
              
I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
              
    GOTO C

J: LOCATE 23, 5: INPUT " ENTER <R> TO REPEAT WITH NEW MU, OR <X> TO EXIT"; W$
      IF W$ = "R" THEN GOTO A
      IF W$ = "X" THEN END
      IF W$ = "" THEN GOTO A
B:   '**********  COORDINATE SYSTEM  *************
     CLS
     LOCATE 1, 22: PRINT " THE PHASE PORTRAIT OF A DAMPED PENDULUM"
     LOCATE 4, 10: PRINT " MU = "; MU; ", FOR NEW MU = <M>,     TO EXIT = <X>"

     PI = 3.141529
     LINE (20, 200)-(600, 200), DBL
     LINE (310, 20)-(310, 360), DBL
     FOR I = 1 TO 3
     FOR J = 1 TO 4
     PSET (310 + MX * I * PI, 200 - J), DBL
     PSET (310 - MX * I * PI, 200 - J), DBL
     NEXT J
     NEXT I
     FOR J = 1 TO 4
     PSET (310, 400 - J), DBL
     NEXT J
     FOR I = 1 TO NY
     FOR J = 1 TO 3
     PSET (310 + J, 200 - MY * I), DBL
     PSET (310 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN


