
SCREEN 9
'5-1A
RANDOMIZE TIMER
LOCATE 10, 1
PRINT "               THE DYNAMICS OF THE LOTKA-VOLTERRA EQUATIONS"
PRINT ""
PRINT ""
PRINT "               DN(1)/DT =    R1 * N(1) - K1 * N(1) * N(2)"
PRINT ""
PRINT "               DN(2)/DT =  - R2 * N(2) + K2 * N(1) * N(2)"
PRINT ""
                            
PRINT "      PRESENTED HERE IN THE `EMPIRICAL DISPLAY' OF X(1, T), X(2,T),VS T"
PRINT ""
C: IF INKEY$ = "" THEN GOTO C
CLS
 N = 2
 DT = .005
 MX = 20: MY = 55

R1 = 1.2: R2 = 1.32
K1 = 1.42: K2 = 1.12
N(1) = 3: N(2) = 2: GOTO EA

'***** RANDOM INITIAL CONDITIONS
E: N(1) = 3 * RND
   N(2) = 3 * RND
 
EA: GOSUB F
'LOCATE 4, 15: PRINT "INITIAL N(1) ="; N(1); ", AND N(2) ="; N(2)

G: '**********  THE FOURTH-ORDER RUNGE-KUTA ITERATION ************
    
     IF MX * T > 600 THEN GOSUB F
     CT = CT + 1
    
    FOR I = 1 TO N
    Y(I) = N(I)
    NEXT I
     
     J = 0
D1:  J = J + 1
   
    '*************** THE LOTKA-VOLTERRA EQUATIONS *******
      K(J, 1) = DT * (R1 * Y(1) - K1 * Y(1) * Y(2))
      K(J, 2) = DT * (-R2 * Y(2) + K2 * Y(1) * Y(2))
      '****************************************************
     
      ON J GOTO E1, F1, G1, H1:  'THE FOUR ITERATIONS
E1: T = T + .5 * DT
       FOR I = 1 TO N
       Y(I) = N(I) + K(1, I) / 2
       NEXT I
       GOTO D1
F1:  FOR I = 1 TO N
       Y(I) = N(I) + K(2, I) / 2
       NEXT I
       GOTO D1
G1: T = T + .5 * DT
       FOR I = 1 TO N
       Y(I) = N(I) + K(3, I) / 2
       NEXT I
       GOTO D1
H1: FOR I = 1 TO N
       N(I) = N(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
       NEXT I
  
   IF CT = 1 THEN GOTO H

    LINE (20 + MX * T, 300 - MY * N(1))-(20 + MX * (T - DT), 300 - MY * LN(1)), 9
    LINE (20 + MX * T, 300 - MY * N(2))-(20 + MX * (T - DT), 300 - MY * LN(2)), 10

H: LN(1) = N(1): LN(2) = N(2)
   
   A$ = INKEY$
   IF A$ = "N" THEN GOTO E  'NEW INITIAL VALUES
   IF A$ = "C" THEN GOSUB F 'CLEARS SCREEN
   IF A$ = "X" THEN END

 ' GOTO G '******* TO ACTIVATE THESE CHOICES, REMOVE THE APOSTROPHE IN FRONT
   IF CT > 1 THEN GOTO GA
   LOCATE 3, 10: PRINT " TO INCREASE/DECREASE K1 OR K2, <U>/<D> OR <H>/<L> RESPECTIVELY"
GA: IF A$ = "" THEN GOTO G
   IF A$ = "U" THEN K1 = K1 + .1
   IF A$ = "D" THEN K1 = K1 - .1
   IF A$ = "H" THEN K2 = K2 + .1
   IF A$ = "L" THEN K2 = K2 - .1
   GOSUB F
GOTO G


F: CLS
   CT = 0
   T = 0
   LINE (400, 15)-(575, 15), 14
'** THE N(1), X(T) VS T COORDINATE SYSTEM
   LINE (20, 20)-(20, 310), 11
   LINE (20, 310)-(610, 310), 11
LOCATE 1, 5: PRINT " TO CLEAR, <C>;   NEW INITIAL STATE, <N>;     K1 ="; K1; ",  K2 ="; K2

   RETURN


