
SCREEN 9
'5-1B
RANDOMIZE TIMER
LOCATE 10, 1
PRINT "               THE DYNAMICS OF THE LOTKA-VOLTERRA EQUATIONS"
PRINT ""
PRINT "           FOR THE `PREDATOR-PREY' MODEL OF INTERACTING SPECIES,"
PRINT "                    AND ALSO SOME CHEMICAL REACTIONS"
PRINT ""
PRINT "               THE TWO ANIMAL OR CHEMICAL CONCENTRATIONS ARE"
PRINT "                     REPRESENTED BY N(1) AND N(2)"
PRINT ""
PRINT "    SINCE THESE CAN NOT BE NEGATIVE, THEIR PHASE SPACE IS IN THE FIRST QUADRANT "
PRINT ""
A: IF INKEY$ = "" THEN GOTO A
CLS
LOCATE 8, 1
PRINT "                   THE LOTKA-VOLTERRA EQUATIONS ARE"
PRINT ""
PRINT "               DN(1)/DT =    R1 * N(1) - K1 * N(1) * N(2)"
PRINT ""
PRINT "               DN(2)/DT =  - R2 * N(2) + K2 * N(1) * N(2)"
PRINT ""
PRINT "WHERE R1,R2,K1,K2 > 0, AND  N(1),N(2) > 0 (PHASE SPACE IN THE POSITIVE QUADRANT)                                 "
PRINT ""
B: INPUT "                  WHICH IS THE PREDATOR, 1 OR 2 "; WH
IF WH = 0 THEN GOTO B
IF WH > 2 THEN GOTO B
IF WH = 1 THEN SOUND 1200, 4: SOUND 600, 6: PRINT ""
IF WH = 1 THEN PRINT "     GIVE IT SOME THOUGHT!  WHICH WILL VANISH IF THE OTHER IS NOT THERE???": GOTO B
PRINT ""
IF WH = 2 THEN PRINT "                      ***YOU HAVE THE IDEA!***"
C: IF INKEY$ = "" THEN GOTO C
CLS
LOCATE 8, 8: PRINT "             AN IMPORTANT FEATURE OF NONLINEAR EQUATIONS"
LOCATE 10, 8: PRINT "  IS THAT SOME PARAMETERS CAN BE ELIMINATED BY SCALING THE VARIABLES"
LOCATE 12, 8: PRINT "      THIS CONCEPT WILL BE LEFT FOR YOU TO CONSIDER IN EXPLORE 5.1B"
LOCATE 14, 8: PRINT " HERE WE WILL SIMPLY LOOK AT THE DYNAMICS FOR GIVEN PARAMETER VALUES"
LOCATE 16, 8: PRINT "         SEE THE PROGRAM FOR MODIFICATIONS OF THE PARAMETERS"
LOCATE 18, 8: PRINT "     AS IN THE LAST CHAPTER, THE FOURTH-ORDER RUNGE-KUTTA IS USED"

D: IF INKEY$ = "" THEN GOTO D
 N = 2
 DT = .003
 MX = 70: MY = 50

'**** HERE THE EQUATIONS (5.1.1), (5.1.2) ARE USED
'**** YOU CAN CHANGE TO (M1,M2) EQUATIONS, (5.1.4), (5.1.5)
'**** WHICH ONLY INVOLVE THE PARAMETER R1, R2 - SEE EXPLORE 5.1B

 '**** THE SELECTED VALUES FOLLOW, CHANGE A FEW TO SEE WHY!
 '**** BETTER YET, FIND SOME MORE INTERESTING CASES
     R1 = 1.2: R2 = 1.32
     K1 = 1.42: K2 = 1.12

F: CLS
   LINE (300, 15)-(475, 15), 14
'** NEW PHASE SPACE COORDINATES (THE POSITIVE QUADRANT)
   LINE (10, 20)-(10, 310), 11    'A VERTICAL LINE AT X = 10
   LINE (10, 310)-(610, 310), 11  'A HORIZONTAL LINE AT Y = 300
   LOCATE 1, 10: PRINT " TO CLEAR, <C>;              NEW INITIAL STATE, <N> "
   LOCATE 21, 60: PRINT " IS THIS AXIS FOR"
   LOCATE 22, 60: PRINT " PREDATOR OR PREY ??"

'***** RANDOM INITIAL CONDITIONS
E: CL = 9 + 5 * RND  '*** MAY CHANGE COLORS FOR DIFFERENT INITIAL CONDITIONS
   N(1) = 4 * RND
   N(2) = 4 * RND
   CT = 0
   LOCATE 3, 15: PRINT "INITIAL N(1) ="; N(1); ", AND N(2) ="; N(2)

G: '**********  THE FOURTH-ORDER RUNGE-KUTA ITERATION ************
 
     CT = CT + 1
    
     FOR I = 1 TO N
     Y(I) = N(I)
     NEXT I
 
     J = 0
D1:  J = J + 1
    '*************** THE N DYNAMIC FUNCTIONS ************
      K(J, 1) = DT * (R1 * Y(1) - K1 * Y(1) * Y(2))
      K(J, 2) = DT * (-R2 * Y(2) + K2 * Y(1) * Y(2))
     '****************************************************
    ON J GOTO E1, F1, G1, H1:  'THE FOUR ITERATIONS
E1: T = T + .5 * DT
       FOR I = 1 TO N
       Y(I) = N(I) + K(1, I) / 2
       NEXT I
       GOTO D1
F1:  FOR I = 1 TO N
       Y(I) = N(I) + K(2, I) / 2
       NEXT I
       GOTO D1
G1: T = T + .5 * DT
       FOR I = 1 TO N
       Y(I) = N(I) + K(3, I) / 2
       NEXT I
       GOTO D1
H1: FOR I = 1 TO N
       N(I) = N(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
       NEXT I
  
   IF CT = 1 THEN GOTO H
   LINE (20 + MX * N(1), 300 - MY * N(2))-(20 + MX * LN(1), 300 - MY * LN(2)), CL
  
   GOTO H  '###### TO ACTIVATE THE TIME MARKS, INSERT AND APOSTROPHE
   TT = TT + 1
   IF TT < INT(.5 / DT) THEN GOTO H   '*** MARK EVERY 0.5 `SEC' - MODIFY
   CIRCLE (20 + MX * N(1), 300 - MY * N(2)), 3, 14
   TT = 0
   '*****
H: LN(1) = N(1): LN(2) = N(2)
   
   A$ = INKEY$
   IF A$ = "C" THEN GOSUB F 'CLEARS SCREEN
   IF A$ = "N" THEN GOTO E  'NEW INITIAL VALUES

GOTO G


