'5-2A
SCREEN 9
LOCATE 3, 10: PRINT "         AN ECOLOGICAL MODEL OF A HOST-PARASITOID SYSTEM"
LOCATE 6, 10: PRINT "    THE POPULATIONS OF THE HOST AND PARASITOIDS ARE H(T), P(T)"
LOCATE 8, 5: PRINT "  ON AVERAGE EACH HOST PRODUCES K EGGS EACH GENERATION, AND THEN DIES"
LOCATE 10, 5: PRINT "   PARASITOIDS ONLY SURVIVE INTO THE NEXT GENERATION IF THEY FIND AN EGG"
LOCATE 12, 5: PRINT "        FROM EACH INFECTED EGG N PARASITOIDS ARE GENERATED"
LOCATE 13, 5: PRINT "      HENCE EACH EGG GIVES RISE TO EITHER A NEW HOST OR ELSE TO N PARASITOIDS,"
AA: IF INKEY$ = "" THEN GOTO AA
CLS
LOCATE 5, 7: PRINT " ASSUME THAT THE PARASITOID'S SEARCHING EFFICIENCY FOR FINDING AN EGG"
LOCATE 7, 7: PRINT " IN GENERATION T IS RELATE TO A FUNCTION E(P(T)) = EXP( - A P(T)),"
LOCATE 9, 4: PRINT " WHERE A IS A CONSTANT, AND E(P(T)) = THE FRACTION OF EGGS THAT ARE *MISSED*."
LOCATE 11, 4: PRINT " THE LARGER IS A, THE MORE EFFEFECTIVE ARE THE PARASITOIDS IN FINDING EGGS "
LOCATE 13, 7: PRINT "             THEN THE EQUATIONS OF MOTION ARE"
LOCATE 15, 7: PRINT "                 H(T+1) = K H(T) E(P(T))"
LOCATE 17, 7: PRINT "                 P(T+1) = N K H(T) (1-E(P(T))"


'DEFINT H, K, N, P'**** THESE ARE ROUNDED OFF TO THE NEAREST INTEGER

B:
   N = 1  '*** PREY PRODUCTION FROM ONE EGG
   K = 2  '*** REPRODUCTION RATE OF HOST

C: ' **** RANDOM INITIAL STATE
   PFP = LOG(K)                     '*** FIXED POINTS
   HFP = LOG(K) / (N * (K - 1))    '********
   P = PFP + ((1 - 2 * RND) / 10)
   H = HFP + ((1 - 2 * RND) / 10)

   LOCATE 4, 40: PRINT " H ="; H; ", P = "; P; "  "

D: CLS
   MX = 200      '** GRAPHIC SCALING
   MY = 150
   CIRCLE (10 + MX * HFP, 300 - MY * PFP), 3, 11
   LINE (10, 300)-(600, 300), 9
   LINE (10, 30)-(10, 300), 9

   LOCATE 1, 15: PRINT " N="; N; "PARASITOIDS ARE GENERATED PER INFECTED EGG "
   'PRINT ""
   PRINT "                     <S> FOR NEW INITIAL STATE"
   LOCATE 4, 3: PRINT "PARASITOIDS                               "
   LOCATE 3, 50: PRINT "K ="; K; ", N ="; N; ""
   LOCATE 21, 70: PRINT "HOSTS"
   G = 0
A: '**** ITERATION LOOP ****
   G = G + 1
   FOR I = 1 TO 30000
   NEXT   '***** SLOWS THE ITERATIONS - CHANGE TO YOUR NEEDS

   A$ = INKEY$
   'IF A$ = "A" THEN GOTO B ' NEW VALUE OF A
   IF A$ = "C" THEN GOTO D  ' CLEARS SCREEN
   IF A$ = "S" THEN GOTO C  ' NEW INITIAL STATE (RANDOM)


'******* RECURSIVE RELATION
   NH = K * H * EXP(-P)
   NP = N * K * H * (1 - EXP(-P))
'**************************

'******************  HISTORY '?????????????????
OOH = OH
OOP = OP
OH = H
OP = P
'******************
  H = NH
  P = NP

LOCATE 4, 40: PRINT " H ="; H; ", P = "; P; "              "
LOCATE 5, 40: PRINT " GENERATION ="; G
'LOCATE 6, 30: PRINT "OH ="; OH; ", OP ="; OP; "       "  '?????
'LOCATE 7, 30: PRINT "OOH ="; OOH; ",00P ="; OOP; "     " '?????????????
 
IF P < 10 ^ -8 THEN P = 0
IF P = 0 THEN SOUND 800, 3:
IF P = 0 THEN LOCATE 10, 35: PRINT "       P = 0, SO WHAT WILL HAPPEN TO H ?"
IF P = 0 THEN LOCATE 13, 35: INPUT "       <S> NEW INITIAL CONDITIONS"; P$
IF P = 0 AND P$ <> "S" THEN GOTO B
IF P = 0 AND P$ = "S" THEN GOTO C


IF H < 10 ^ -8 THEN H = 0
IF H = 0 THEN SOUND 300, 3
IF H = 0 THEN LOCATE 14, 35: PRINT "         H = 0, SO WHAT WILL HAPPEN TO P?"
IF H = 0 THEN LOCATE 16, 35: INPUT "        <S> FOR NEW INITIAL CONDITIONS"; H$
IF H = 0 AND H$ <> "S" THEN GOTO B
IF H = 0 AND H$ = "S" THEN GOTO C

CIRCLE (10 + MX * H, 300 - MY * P), 3, 14

GOTO A


