   CLS
   '5-4
    SCREEN 9
    RANDOMIZE TIMER
    N = 2
    GRN = 10: LBL = 11: RED = 12: DBL = 9: MAG = 13
    M = 100: DT = .03
    DIM X(N), K(4, N), Y(N), OX(N)
   '******************
    LOCATE 1, 10: PRINT "THE BONHOEFFER-VAN DER POL MODEL OF THE DYNAMICS OF A NEURON "
    LOCATE 2, 10: PRINT "                DUE TO R. FITZHUGH IN 1961 "
    LOCATE 5, 10: PRINT "        THE NEURON CAN BE EXCITED AT ANY TIME BY <E>"
    LOCATE 7, 10: PRINT "       TO INCREASE/DECREASE THE EXCITATION, <I>/<D>"
    LOCATE 9, 10: PRINT "  ENVIRONMENTAL NOISE INPUT CAN BE TURNED ON/OFF BY <N>/<F>"
    LOCATE 11, 8: PRINT "TO RETURN FOR NEW Z, <R>; TO CLEAR SCREEN, <C>; TO EXIT RUN, <X>"
    PRINT ""
    PRINT ""
    PRINT "                   THE FIXED POINT IS STABLE (QUIESCENT NEURON) "
    PRINT "            *AND* HAS AN INFINITE BASIN OF ATTRACTION IF  Z > -.336"
A:  PRINT ""
    INPUT "                      SELECT Z (E.G., TRY Z = - 0.25)="; Z
    PRINT ""
    INPUT "                      EXCITATION STRENGTH (E.G., 4), EXC ="; EXC
    CT = 0: NZ = 0
    FOR I = 1 TO N
    X(I) = -3 * RND
    NEXT I
J:  CLS
    A = .7: B = .8: C = 3: ' FOR STRONGER RELAXATION, TAKE LARGER C
C:  GOSUB B

I:  '************************* ITERATION LOOP ********************
    A$ = INKEY$
    IF A$ = "X" THEN END
    IF A$ = "C" THEN GOTO J: ' CLEARS SCREEN
    IF A$ = "R" THEN GOTO A: ' RETURNS FOR NEW Z
    IF A$ = "I" THEN EXC = EXC + .1  '*** STRONGER EXCITATION
    IF A$ = "D" THEN EXC = EXC - .1
    IF A$ = "L" OR A$ = "S" THEN GOSUB B
    E = 0
    IF A$ = "E" THEN E = EXC: ' EXCITES; CAN VARY STRENGTH
    IF A$ = "E" THEN BEEP
    IF A$ = "N" THEN NMAX = .3: 'NOISE ON; NMAX = MAXIMUM STRENGTH
    IF A$ = "F" THEN NMAX = 0: ' NOISE OFF
    IF A$ = "N" OR A$ = "F" THEN GOSUB B
    NZ = NMAX * (1 - 2 * RND)
    CT = CT + 1
    IF CT > 6000 THEN GOSUB B: 'TO KEEP GRAPH OF X(T) ON THE SCREEN
    IF CT > 6000 THEN CT = 1
    FOR I = 1 TO N
    Y(I) = X(I)
    NEXT I
     J = 0
D:   J = J + 1
     K(J, 1) = DT * C * (Y(1) - Y(1) * Y(1) * Y(1) / 3 + Y(2) + Z - E + NZ)
     K(J, 2) = DT * (A - Y(1) - B * Y(2)) / C
     IF J = 1 THEN GOTO E
     IF J = 2 THEN GOTO F
     IF J = 3 THEN GOTO G
     IF J = 4 THEN GOTO H
E:   T = T + .5 * H
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D
G:  T = T + .5 * H
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + (1 / 6) * (K(1, I) + 2 * K(2, I) + 2 * K(3, I) + K(4, I))
    NEXT I
    IF CT = 1 THEN GOTO K
    LINE (320 + M * X(1), 200 - M * .731 * X(2))-(320 + M * OX(1), 200 - M * .73 * OX(2)), LBL
    LINE (10 + .1 * CT, 290 + 25 * X(1))-(10 + .1 * (CT - 1), 290 + 25 * OX(1)), RED
K:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
     GOTO I
B:   '********** GRAPHICS COORDINATE SYSTEM ****************
     CLS
     LOCATE 1, 1: PRINT " TO EXCITE, <E>;    NOISE ON,<N>;  OFF, <F>;    Z = "; Z; ", FOR NEW Z, <R>"
     LOCATE 2, 1: PRINT " TO CLEAR SCREEN, <C>    TO EXIT, <X>"
     LOCATE 2, 45: PRINT " EXCITATION, EXC = "; EXC
     LOCATE 3, 10: PRINT " THE NOISE MAX. ="; NMAX
     LOCATE 3, 42: PRINT " TO INCREASE/DECREASE EXC, <I>/<D>"
     LINE (20, 200)-(620, 200), DBL
     LINE (320, 20)-(320, 380), DBL
     FOR I = 0 TO 3
     FOR J = 1 TO 4
     PSET (320 - M * I, 200 - J), DBL
     PSET (320 + M * I, 200 - J), DBL
     NEXT J
     NEXT I
     FOR J = 1 TO 4
     PSET (320, 400 - J), DBL
     NEXT J
     FOR I = 0 TO 4
     FOR J = 1 TO 3
     PSET (320 + J, 200 - M * .731 * I), DBL
     PSET (320 + J, 200 + M * .731 * I), DBL
     NEXT J
     NEXT I
     '***** THE ISOCLINE DT/DX=0 *****
     FOR I = 0 TO 440
     X = -2.2 + .01 * I
     Y = -X + (1 / 3) * X ^ 3 - Z
     PSET (320 + M * X, 200 - M * .731 * Y), MAG
     NEXT I
     '*** THE ISOCLINE DY=DT=0 ***
     FOR I = 0 TO 180
     X = -.3 + .01 * I
     Y = (A - X) / B
     PSET (320 + M * X, 200 - M * .731 * Y), MAG
     NEXT I
     RETURN



