'7-1
SCREEN 9
PRINT ""
PRINT ""
PRINT "          HERE WE WILL CONSIDER A DAMPED HARMONIC OSCILLATOR"
PRINT ""
PRINT "     WHICH MEANS THAT IT TENDS TO *DIE* IN TIME, IF IT IS LEFT ALONE"
PRINT ""
PRINT "      BUT WE ARE GOING TO ADD A PERIODIC FORCING ACTION, A*COS(O*T)"
PRINT ""
PRINT "     SO THE EQUATIONS OF MOTION ARE:"
PRINT ""
PRINT "           DX/DT = Y ;           DY/DT = -X - MU*Y + A*COS(O*T) "
PRINT ""
PRINT "  WHERE THE DAMPING IS SMALL, MU = 0.1, AND THE NATURAL FREQUENCY IS W =1"
PRINT ""
PRINT "      BEGIN BY CONSIDERING THE CASE OF A WEAK FORCE, SAY A = 0.1"
PRINT "     "
PRINT "  SEE HOW THE ASYMPTOTIC AMPLITUDE OF THE OSCILLATOR CHANGES AS O IS INCREASED"
PRINT ""
PRINT "              FROM AROUND O= 0.75 TO VALUES ABOVE W = 1"
PRINT ""
PRINT "     COMPARE THE ACTUAL ASYMPTOTIC AMPLITUDE WITH THE THEORETICAL RESONANCE"


      MX = 200: MY = .83 * MX   ' GIVES THE GRAPHICS MAGNIFICATION BELOW
        
    PRINT ""
   
    LINE (10, 295)-(600, 295), 12  'COLORED UNDERLINE
G:  INPUT "SELECT SMALL A (E.G., A = .1), AND FIRST INCREASE O FROM O = 0.7;  A,O ="; A, O
    GOTO GA
Q:  PRINT ""
    INPUT "    SEE THE INCREASE IN AMPLITUDE IF A = 0.15, START AT O = .8; A, O="; A, O
GA: X = (1 - 2 * RND): Y = (1 - 2 * RND)'RANDOM INITIAL CONDITIONS (-1<X,Y<1)
    OX = 0: OY = 0   'JUST SETS UP SOME NUMBERS USED BELOW
    DT = .03         'THE TIME STEP IN THE DYNAMICS
    

  GOSUB F  ' THE COORDINATE GRAPHICS

D: '********** THE BEGINNING OF THE ITERATION LOOP ************
  CT = CT + 1  '*** USED TO ONLY GRAPH THE ASYMPTOTIC DYNAMICS, CT>2000
  A$ = INKEY$
  IF A$ = "C" THEN GOSUB F 'WILL REFRESH SCREEN ANY TIME YOU STRIKE *CAPITAL* C
  IF A$ = "G" THEN GOTO G  'STRIKE G TO CHANGE THE PERIODIC ACTION
  IF A$ = "I" THEN O = O + .02
  IF A$ = "I" THEN CT = 0  'FOR GRAPHICS
  IF O > 1.2 THEN SOUND 800, 4
  IF O > 1.2 THEN GOTO Q
  IF A$ = "D" THEN O = O - .02
  IF A$ = "D" THEN CT = 0
  IF A$ = "X" THEN END
  IF A$ = "" THEN GOTO E
  LOCATE 5, 5: PRINT "A  ="; A; ", O ="; O; "       "
   X0 = A / SQR((1 - O ^ 2) ^ 2 + MU ^ 2 * O ^ 2)
  
   CIRCLE (320 + MX * X0, 200), 3, 11
   GOSUB Z
E:   T = T + DT
    F = A * COS(O * T)  'THE PERIODIC-FORCE INTERACTION
  
   '************* A MODIFIED EULER APPROXIMATION *********
   MU = .15
   X = X + DT * Y
   Y = Y + DT * (-MU * Y - X + F)'THE DAMPING IS -MU*Y*DT TERM, PLUS THE F ACTION
  
   IF OX = 0 THEN GOTO D1  'NO LINE FROM THE ORIGIN
   X0 = A / SQR((1 - O ^ 2) ^ 2 + MU ^ 2 * O ^ 2)
   CIRCLE (320 + MX * X0, 200), 3, 11
  
   IF CT < 2000 THEN GOTO D1  '**** ONLY THE ASYMPTOTIC DYNAMICS IS GRAPHED
   LINE (320 + MX * X, 200 - MY * Y)-(320 + MX * OX, 200 - MY * OY), 14

D1:   OX = X: OY = Y

GOTO D  '******** END OF LOOP *******

F: CLS
   LOCATE 1, 15: PRINT " PERIODIC ACTION ON A DAMPED HARMONIC OSCILLATOR"
   LINE (320, 20)-(320, 350), 9   'A VERTICAL LINE AT X = 10, COLOR = 9
   LINE (10, 200)-(610, 200), 9   'A HORIZONTAL LINE AT Y = 200
   LOCATE 3, 50: PRINT " <C> = CLEAR SCREEN"
   LOCATE 3, 2: PRINT "*SLOWLY* INCREASE/DECREASE O, <I>/<D> "
   LOCATE 5, 5: PRINT "A  ="; A; ", O ="; O; "       "
   CIRCLE (335, 64), 3, 11
   LOCATE 5, 44: PRINT "= THEORETICAL ASYMPTOTIC AMPLITUDE"
  '***** LABELING AXES
   LOCATE 16, 75: PRINT "X": LOCATE 3, 42: PRINT "Y"
 
   RETURN


Z: '**** THE THEORETICAL ASYMPTOTIC AMPLITUDE RESONANCE CURVE
    '*****  YOU CAN ADD THE COORDINATES IF YOU LIKE !

    CIRCLE (250 * O - 150, 380 - 220 * X0), 3, 11
    RETURN



                                   


