
   CLS
   '7-3B
    SCREEN 9
    RANDOMIZE TIMER
    PRINT "           SYMMETRY BREAKING, MULTIPLE ATTRACTORS, CHAOS"
    PRINT "    AND THE POINCARE MAP FOR THE VERY STRONGLY FORCED DUFFING OSCILLATOR "
    PRINT ""
    PRINT "          DX/DT = Y  ; DY/DT = - MU Y - X - EPS *X ^ 3 + C SIN(OMEGA*T) "
    PRINT ""
              MU = .1: OMEGA = 1: EPS = 1  '***
    PRINT "            WHERE  MU ="; MU; "(NOTE!),  EPS ="; EPS; "    OMEGA ="; OMEGA
    PRINT ""
    PRINT ""
    PRINT "          THIS IS SET UP TO EXPLORE LARGER VALUES OF C, YIELDING "
    PRINT "                MULTIPLE PERIODIC AND CHAOTIC ATTRACTORS       "
    PRINT ""
    PRINT "              BEGIN WITH C NEAR 25, THEN SLOWLY INCREASE C"
    PRINT ""
    PRINT "   THIS PROGRAM WILL SHOW EITHER THE USUAL PHASE DIAGRAM OR THE POINCARE MAP"
    PRINT "                     YOU CAN SELECT WHICH YOU WANT"
    INPUT "                  TO SEE ONLY THE POINCARE MAP, <P>"; P$
    CLS
    PRINT ""
    LOCATE 5, 1:
    PRINT ""
    PRINT "           FOR FIXED VALUES OF C, INCREASE THE VALUE OF THE INITIAL XO"
    PRINT "                    AND DETERMINE NEW TYPES OF `BOUNDARIES' (OF WHAT?) "
    PRINT ""
    PRINT "     THEN INCREASE C, SEE WHAT YOU FIND!  IF IT'S CHAOS, USE THE POINCARE MAP "
    DEFDBL A-Z
    LOCATE 20, 15: INPUT " SELECT THE INITIAL VALUE OF C NEAR 20 ="; C
    N = 2
    DIM X(N), OX(N), Y(N), K(4, N)
    MU = .1: OMEGA = 1: EPS = 1
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
    PRINT ""
    PRINT "      THE INITIAL VALUE OF X(1) CAN BE RAISED OR LOWERED, USING <R>/<L>"
    INPUT "  SELECT THE INITIAL CONDITION, X(1) AT X0(1) = 0 ( X(2)=0 IS USED), X0(1)="; X0(1)
    
K:  CT = 0: TT = 0
    T = 0
    IF P$ <> "P" THEN M = 25
    IF P$ <> "P" THEN MX = M: MY = .5 * M
     GY = 200
     IF P$ = "P" THEN GY = 250
      SZ = 3
      IF P$ = "P" THEN SZ = .6  '** CHANGE CIRCLE SIZE FOR POINCARE MAP
      IF P$ = "P" THEN M = 40: MX = M: MY = .5 * M
   
   
    IF A$ = "R" THEN X0(1) = X0(1) + .1
    IF A$ = "L" THEN X0(1) = X0(1) - .1
    X0(2) = 0
    X(1) = X0(1): X(2) = X0(2)
    GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM
J:  LOCATE 1, 15: PRINT "   C ="; INT(100 * C) / 100; ",         X0(1) ="; INT(100 * X0(1)) / 100; "      "
    NP = 150#   'NUMBER OF ITERATIONS PER PERIOD
    DT = 6.283185307# / (NP * OMEGA)

C:         ' ******** ITERATION LOOP *************
     
     A$ = INKEY$
     IF A$ = "C" THEN GOSUB B: 'CLEAR AND CONTINUE
     IF A$ = "I" THEN C = C + .5
     IF A$ = "I" THEN GOTO J
     IF A$ = "D" THEN C = C - .5
     IF A$ = "D" THEN GOTO J
     IF A$ = "R" THEN GOTO K: ' NEW INITIAL CONDITIONS
     IF A$ = "L" THEN GOTO K: ' NEW INITIAL CONDITIONS
     IF A$ = "X" THEN END
     CT = CT + 1
    
     TT = TT + 1   '**** USED TO PUT CIRCLE ON ORBIT EVERY APPLIED PERIOD
     IF TT >= NP THEN CIRCLE (320 + MX * X(1), GY - MY * X(2)), SZ, LBL
     IF TT >= NP THEN TT = 0
    
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
   
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     '**** THE N DYNAMIC FUNCTIONS ****
     F(1) = Y(2)
     F(2) = -MU * Y(2) - Y(1) - Y(1) * Y(1) * Y(1) + C * SIN(OMEGA * T)
     '*********************************
     K(J, 1) = DT * F(1)
     K(J, 2) = DT * F(2)
    
     ON J GOTO E, F, G, H
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
    IF CT = 1 THEN GOTO I
    '****** FOR THE POINCARE MAP
    IF P$ = "P" THEN GOTO I
    LINE (320 + MX * X(1), GY - MY * X(2))-(320 + MX * OX(1), GY - MY * OX(2)), YEL
   

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I
    GOTO C
B:  '****************** GRAPHICS COORDINATE SYSTEM  ****************
     CLS
     LOCATE 1, 15: PRINT "   C ="; INT(100 * C) / 100; ",         X0(1) ="; INT(100 * X0(1)) / 100; "      "
     CIRCLE (320 + MX * X0(1), GY - MY * X0(2)), 4, MAG '*** INITIAL CONDITION
     LOCATE 1, 55: PRINT " CLEAR =<C>"
     LOCATE 3, 10: PRINT " <R>/<L> TO RAISE/LOWER X0(1)"
     LOCATE 3, 45: PRINT " <I>/<D> TO INCREASE/DECREASE C"
     
     NX = 300 / MX: NY = 190 / MY: ' NUMBER OF UNIT INTERVALS
     LINE (20, GY)-(620, GY), DBL
     LINE (320, 20)-(320, 380), DBL
     FOR I = 1 TO NX
     FOR J = 1 TO 4
     PSET (320 + MX * I, GY - J), DBL
     PSET (320 - MX * I, GY - J), DBL
     NEXT J
     NEXT I
     FOR J = 1 TO 4
     PSET (320, 400 - J), DBL
     NEXT J
     FOR I = 1 TO NY
     FOR J = 1 TO 3
     PSET (320 + J, GY - MY * I), DBL
     PSET (320 + J, GY + MY * I), DBL
     NEXT J
     NEXT I
     RETURN



