    CLS
   '7-4
    SCREEN 9
    RANDOMIZE TIMER
    N = 2:
    DIM X(N), OX(N), Y(N), K(4, N)
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
    LOCATE 5, 10: PRINT "   A PACEMAKER CELL IS MODELED BY A VAN DER POL OSCILLATOR"
    PRINT ""
    PRINT "        CIRCADIAN RHYTHMS ARE PRODUCED BY ENTRAINMENT OF A PACEMAKER CELL "
    PRINT ""
    PRINT "       TO THE PERIOD OF THE ENVIRONMENT, 2 PI/OMEGA, (THE ZEITGEBER)"
    PRINT ""
    PRINT ""
    PRINT "        THE VAN DER POL DYNAMICS WITH THE ZEITBEBER ACTION IS GIVEN BY "
    PRINT ""
    PRINT "          DX/DT = Y    DY/DT = - X + K (1- X^2) Y + A COS(OMEGA T)"
    PRINT ""
    PRINT "       WHERE A*COS(OMEGA * T) IS THE ENVIRONMENTAL PERIODIC INFLUENCE"
    PRINT ""
AA: INPUT "      SELECT THE NONLINEARITY OF THE PACEMAKER CELL (BEGIN WITH K = 1), K ="; K
    INPUT " THIS BEGINS WITH NO INTERACTION, A = 0, AND THE ENVIRONMENTAL OMEGA = 1;  <>  "; STANDARD$
     A = 0: OMEGA = 1
    
    M = 35
    MX = M: MY = .73 * M
    DT = .03
    SND = 0 '*** PERIODIC SOUNDS OF THE PACEMAKER AND ZEITGEBER INITIALLY OFF
    FOR I = 1 TO N
    X(I) = 3 * (1 - 2 * RND)
    NEXT I

A:  CLS
    LOCATE 1, 15: PRINT "**** ENTRAINING THE VAN DER POL PACEMAKER ****"
 
    PRINT "          DX/DT = Y ;      DY/DT = -X + K*(1 - X^2)*Y + A*COS(OMEGA* T)"
    
     LOCATE 3, 25: PRINT " A ="; A; ",    K = "; K; ",   OMEGA ="; OMEGA; ""
     LOCATE 4, 10: PRINT " INCREASE/DECREASE A, <I>/<D>"
     LOCATE 4, 45: PRINT " RAISE/LOWER OMEGA, <R>/<L>"
     LOCATE 5, 20: PRINT "PACEMAKER"
     LINE (230, 60)-(280, 60), LBL
     LOCATE 5, 55: PRINT "ZEITGEBER"
     LINE (510, 60)-(560, 60), YEL
     LOCATE 8, 60: PRINT "PACE & ZEIT SOUNDS"
     LOCATE 9, 60: PRINT "  ON/OFF <N>/<F> "
     LOCATE 7, 1: PRINT "ZEITGEBER PERIOD"
     LOCATE 8, 1: PRINT (2 * 3.13125 / OMEGA)
    
     CT = 0
     GY = 180
    OGY = 300 'FOR THE TEMPORAL GRAPH
     LINE (120, GY)-(520, GY), DBL
     LINE (320, 40)-(320, 320), DBL
    
     
C:  ' ***** FOURTH ORDER RUNGE-KUTTA *****

     A$ = INKEY$
     IF A$ = "X" THEN END
     IF A$ = "C" THEN GOTO A  'CLS
     IF A$ = "K" THEN GOTO AA '** NEW NONLINEARITY CONSTANT K
     IF A$ = "I" THEN A = A + .1
     IF A$ = "D" THEN A = A - .1
     IF A$ = "R" THEN OMEGA = OMEGA + .1
     IF A$ = "L" THEN OMEGA = OMEGA - .1
     IF A$ = "F" THEN SND = 0   'SOUND OFF
     IF A$ = "N" THEN SND = 1   'SOUND ON
     IF A$ <> "" THEN LOCATE 3, 25: PRINT " A ="; A; ",    K = "; K; ",   OMEGA ="; OMEGA; ""
     IF A$ <> "" THEN LOCATE 7, 1: PRINT "ZEITGEBER PERIOD"
     IF A$ <> "" THEN LOCATE 8, 1: PRINT (2 * 3.13125 / OMEGA)
   
     CT = CT + 1
     SCX = .2 '*** GRAPHIC X-SCALING
     IF SCX * CT > 600 THEN GOTO A
    
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
    
     '**** FORCED VAN POL OSCILLATOR ****
     K(J, 1) = DT * Y(2)
     K(J, 2) = DT * (-Y(1) + K * (1 - Y(1) ^ 2) * Y(2) + A * COS(OMEGA * T))
     '*********************************
     ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D
F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D
G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I
   
    IF CT = 1 THEN GOTO J
                 
  '*** AMPLITUDES VS TIME GRAPHICS
   LINE (10 + SCX * CT, OGY - 15 * X(1))-(10 + SCX * (CT - 1), OGY - 15 * OX(1)), LBL
   LINE (10 + SCX * CT, OGY + 25 * SIN(OMEGA * T))-(10 + SCX * (CT - 1), OGY + 25 * SIN(OMEGA * (T - DT))), YEL
  
    '*** PHASE PLANE GRAPHICS
    LINE (320 + MX * X(1), GY - MY * X(2))-(320 + MX * OX(1), GY - MY * OX(2)), LBL
    LINE (320 + MX * COS(OMEGA * T), GY + MY * SIN(OMEGA * T))-(320 + MX * COS(OMEGA * (T - DT)), GY + MY * SIN(OMEGA * (T - DT))), YEL
    IF SND = F THEN GOTO I
  
   '***  SOUNDS OF THE PACEMAKER AND ZEITGEBER AS THEY CROSS X(1) > AXIS
   IF COS(OMEGA * T) > 0 AND SIN(OMEGA * T) * SIN(OMEGA * (T - DT)) < 0 THEN SOUND 500, .5
   IF X(1) > 0 AND X(2) * OX(2) < 0 THEN SOUND 1000, .5
  
I: '**PERIOD OF FORCED VAN DER POL OSCILLATOR

   IF X(1) > 0 AND X(2) * OX(2) < 0 THEN LOCATE 10, 1: PRINT (T - OT)
   IF X(1) > 0 AND X(2) * OX(2) < 0 THEN OT = T
   IF X(1) > 0 AND X(1) * OX(1) < 0 THEN LOCATE 9, 1: PRINT "PACEMAKER PERIOD"
   

 '*** PLACES A CIRCLE ON PACEMAKER ORBIT AT EACH PERIOD OF THE ZEITGEBER
   IF COS(OMEGA * T) > 0 AND SIN(OMEGA * T) * SIN(OMEGA * (T - DT)) < 0 THEN CIRCLE (320 + MX * X(1), GY - MY * X(2)), 3, YEL
  
J: FOR I = 1 TO N: OX(I) = X(I): NEXT I
   
   
    GOTO C







