   '8-1A
   RANDOMIZE TIMER
   SCREEN 9
   DIM X(102, 102), NX(102, 102)
A: CLS
    
    PRINT "           A SIMPLE EXCITATION-DIFFUSION SYSTEM MODEL"
    PRINT ""
    PRINT "             CONSISTS OF CELLS ON A SQUARE LATTICE "
    PRINT ""
    PRINT "       WHICH ARE COUPLED TO THEIR FOUR NEAREST-NEIGHBOR CELLS"
    PRINT ""
    PRINT "           THE CELLS CAN BE IN THE STATES 0, 1, OR 2"
    PRINT "         "
    PRINT "   STATE 0 IS REFRACTORY;  STATE 1 IS QUIESCENT;  STATE 2 IS EXCITED"
    PRINT "               WHICH ARE COLOR CODED AS FOLLOWS"
    DBL = 9: LBL = 11: RED = 12: YEL = 14
   
    GY = 145
    LINE (110, GY)-(170, GY), DBL: LINE (210, GY)-(270, GY), LBL
    LINE (310, GY)-(370, GY), RED
    PRINT "            "
    PRINT "                 0            1           2"
    PRINT "        AT EACH TIME STEP THE DYNAMICS FOLLOWS THE RULES:"
    PRINT ""
    PRINT "             STATE 2 GOES TO 0; STATE 0 GOES TO 1"
    PRINT " STATE 1 GOES TO STATE 2 ONLY IF AT LEAST ONE OF 4 NEIGHBORS IS IN STATE 2 "
    PRINT ""
    PRINT "       MOVABLE INITIAL CONDITIONS AND SOME MODIFICATIONS ARE SUPPLIED"
    PRINT ""
    INPUT "  TO ADD A SMALL PERCENTAGE OF RANDOM INITIAL STATES <R>, BEGIN WITH <>"; IC$
    CLS
    LOCATE 10
    M = 4' MAGNIFICATION
    PRINT ""
    LOCATE 10
    PRINT "        <N> = NEW INITIAL CONDITIONS;   <R> = RETURN TO BEGINNING"
    PRINT ""
    PRINT "   THE NEW INITIAL CONDITIONS CONTAIN A SMALL PERCENTAGE OF RANDOM STATES "
    PRINT "                     YOU CAN CHANGE THIS PERCENTAGE"
    PRINT ""
    PRINT "    AFTER 15 TIME STEPS THE DISPLAY WILL STOP UNTIL YOU STRIKE SOME KEY"
    PRINT ""
    INPUT "            SELECT THE SIZE OF THE N-BY-N LATTICE; N (<=27)="; N
    PRINT ""
   
B: CLS
   SOUND 900, 3
    LOCATE 1, 1: PRINT "<>= PROCEED; <N>= NEW INITIAL CONDITIONS; <R>= RETURN TO BEGINNING; <X> = END"
    CT = 0

    ' ******* INITIAL CONDITIONS ** EXPLORE DIFFERENT CHOICES ******
   
    FOR I = 1 TO N
    FOR J = 1 TO N
    X(I, J) = 1 '*** ALL CELLS ARE QUIESCENT HERE, THEN A FEW ARE CHANGED
    NEXT J
    NEXT I
   
    '************ ENTER TRIAL FOR YOUR IDEAS IN THINK 8.1C  ****************
      'FIRST ENTER TWO LOCATIONS OF (I,J) AND TWO STATES FOR THE TWO ?,
      'AFTER THIS ACTIVATE BY REMOVING THE APOSTROPHIES ON THE NEXT TWO LINES
      'THEN START THE PROGRAM, AND SEE WHAT YOU GET FOR LONG TIMES
        ' X(  ,  ) = ?: X(  ,  ) = ?
        ' GOTO A2

A1:        '**** ACTIVATE AND/OR MODIFY THESE SELECTIONS

    '**** A MOVABLE INITIAL STATE SELECTION - MODIFY AND ADD RANDOM SELECTION
              H = 11: V = 10  '** HORIZONTAL AND VERTICAL ADJUSTMENTS
     X(H, V) = 2: X(H + 1, V) = 0: X(H + 2, V) = 2: X(H + 3, 10) = 2: X(H + 4, 10) = 2: X(17, 10) = 2
     X(H, V + 1) = 2: X(H + 1, V + 1) = 0: X(H + 2, V + 1) = 0: X(H + 3, V + 1) = 0: X(16, 11) = 0: X(17, 11) = 0: X(18, 11) = 2
     X(H - 1, V + 8) = 2: X(H, V + 9) = 0
     X(H - 1, V + 11) = 2: X(H, V + 11) = 0

    'X(H, V + 5) = 1: X(H + 1, V + 6) = 0
    'X(H, V + 7) = 2: X(H + 1, V + 7) = 0
    'X(12, 13) = 2: X(13, 13) = 0:  X(15, 13) = 0: X(16, 13) = 2
    'X(12, 14) = 2: X(13, 14) = 2


IF IC$ <> "R" THEN GOTO A2 '******* PLUS A THREE-PERCENT NOISY INPUT ******
  
   FOR I = 1 TO N
   FOR J = 1 TO N
   Z = RND
   IF Z > .97 THEN X(I, J) = 1 + INT(3 * RND)
   NEXT J
   NEXT I

A2:    '****** COLOR DESIGNATION FOR STATES OF CELLS
    FOR I = 1 TO N
    FOR J = 1 TO N
    IF X(I, J) < 1 THEN CL = DBL
    IF X(I, J) = 1 THEN CL = LBL
    IF X(I, J) = 2 THEN CL = RED
    CIRCLE (120 * CT + M * I, 10 + M * J), 2.5, CL
    NEXT J
    NEXT I
    CT = 1

C: '******************* CELL DYNAMICS ***********************
     FOR J = 1 TO N
     FOR I = 1 TO N
     IF X(I, J) = 1 THEN GOSUB E '*** QUIESCENT CELL
     IF X(I, J) < 1 THEN NX(I, J) = X(I, J) + 1
     IF X(I, J) = 2 THEN NX(I, J) = 0
     NEXT I
     NEXT J

     GOTO F

'********** INTERACTIONS ONLY INFLUENCES QUIESCENT CELL ***************

E: '**** COUNTING THE EXICITED NEIGHBORS OF A QUIESCENT CELL
     IF X(I, J + 1) = 2 THEN S = S + 1
     IF X(I, J - 1) = 2 THEN S = S + 1
     IF X(I + 1, J) = 2 THEN S = S + 1
     IF X(I - 1, J) = 2 THEN S = S + 1

'**** SEE WHAT HAPPENS IF EIGHT NEIGHBORS ACT ON CELLS ****

'************ INFLUENCE OF THE SUM OF EXCITED NEIGHBORS *******
     IF S >= 1 THEN NX(I, J) = 2    'QUIESCENT CELL BECOMES EXCITED
     IF S < 1 THEN NX(I, J) = 1     'QUIESCENT CELL REMAINS QUIESCENT
     S = 0
     RETURN

F:   FOR I = 1 TO N
     FOR J = 1 TO N
     X(I, J) = NX(I, J)
     IF X(I, J) < 1 THEN CL = DBL
     IF X(I, J) = 1 THEN CL = LBL
     IF X(I, J) = 2 THEN CL = RED
    
   '********* SEQUENCE DISPLAYED IN DIFFERENT ROWS **********
     IF CT > 9 THEN GOTO H  '*** FIRST ROW
     IF CT > 4 THEN GOTO G  '*** SECOND ROW
     CIRCLE (125 * CT + M * I, 10 + M * J), 2.5, CL
     GOTO I
G:   CIRCLE (125 * (CT - 5) + M * I, 120 + M * J), 2.5, CL
     GOTO I
H:   CIRCLE (125 * (CT - 10) + M * I, 230 + M * J), 2.5, CL

I: NEXT J
   NEXT I
    
     CT = CT + 1
     

IA:   A$ = INKEY$
     IF A$ = "N" THEN IC$ = "R"
     IF A$ = "N" THEN GOTO B  '** NEW INITIAL CONDITIONS
     IF A$ = "R" THEN GOTO A  ' ** RETURN TO BEGINNING
     IF A$ = "X" THEN END
     IF CT > 14 THEN IF A$ = "" THEN GOTO IA
     IF CT > 14 THEN GOTO J
   
     GOTO C

J:   '***** CLEAR SCREEN
     CT = 0
     CLS
     LOCATE 1, 1: PRINT "<>= PROCEED; <N>= NEW INITIAL CONDITIONS; <R>= RETURN TO BEGINNING; <X> = END"
     PRINT ""
     GOTO C


