 '8-2A
  SCREEN 9
  LOCATE 3, 15: PRINT " THIS SHOWS THE DYNAMICS OF THE LORENZ EQUATION"
  LOCATE 5, 15: PRINT "              DX/DT = 10 (Y - X)"
  LOCATE 7, 15: PRINT "              DY/DT = R X - Y - Z X"
  LOCATE 9, 15: PRINT "              DZ/DT = -(8/3) Z + X Y "
  LOCATE 11, 10: PRINT "   GRAPHED IN THREE DIMENSIONS,  USING THE EULER APPROXIMATION"
  LOCATE 12, 10: PRINT "            THE AXES CAN BE ROTATED TO ANY ORIENTATION"
  LOCATE 14, 5: PRINT " NOTE THAT THIS IS A `FAST AND SIMPLE' APPROXIMATION,"
  LOCATE 15, 20: PRINT "    GIVING ONLY A QUALITATIVE INDICATION OF THE DYNAMICS"
AA:     DEFDBL D, R, X-Z
        DEFINT I-K
        TH = 1.4  '*** THE ROTATION ANGLE ABOUT THE Z AXIS
        PHI = .3  '*** THE ANGLE ABOVE THE (X,Y) PLANE
        RM1 = COS(TH) * SIN(PHI)
        RM2 = -SIN(TH) * SIN(PHI)
        RM3 = COS(PHI)
        RM4 = -SIN(TH)
        RM5 = COS(TH)
        MX = 10: MY = 4   '*** GRAPHICS MAGNIFICATION
        SX = 320: SY = 280 '*** ORIGIN LOCATION
        MAX = 200: MAY = 200  '*** AXIS MAGNIFICATION

        PRINT ""
        INPUT "                SELECT R (E.G. 15, THEN INCREASE FROM KEYBOARD), R ="; R
AB:    XI = 4 * (1 - 2 * RND)
       YI = 4 * (1 - 2 * RND)
       ZI = 4 * (1 - 2 * RND)
       CT = 0
       CL = 9 + 4 * RND
        DT = .005
        XNEW = XI: YNEW = YI: ZNEW = ZI: XOLD = XI: YOLD = YI: ZOLD = ZI
       
        GOSUB B


A:   '**** EULER APPROXIMATION - GIVES SPEED, NOT ACCURACY!
        
        DX = 10 * (YOLD - XOLD)
        DY = R * XOLD - YOLD - XOLD * ZOLD
        DZ = -(8 / 3) * ZOLD + XOLD * YOLD
       
       XNEW = XOLD + DX * DT
       YNEW = YOLD + DY * DT
       ZNEW = ZOLD + DZ * DT

       
        OTH = TH
        OPH = PHI
       
        OLDR = R
        A$ = INKEY$
        IF A$ = "X" THEN END
        IF A$ = "I" THEN TH = TH + .1
        IF A$ = "D" THEN TH = TH - .1
        IF A$ = "H" THEN PHI = PHI + .1
        IF A$ = "L" THEN PHI = PHI - .1
        IF A$ = "P" THEN R = R + 1
        IF A$ = "M" THEN R = R - 1
        IF OLDR <> R THEN GOTO AB
        IF A$ = "C" THEN GOSUB B  '*** CLEARS OLD ORBIT
        IF A$ = "N" THEN GOTO AB
        '*******
        RM1 = COS(TH) * SIN(PHI)
        RM2 = -SIN(TH) * SIN(PHI)
        RM3 = COS(PHI)
        RM4 = -SIN(TH)
        RM5 = COS(TH)

    IF OTH <> TH THEN GOSUB B    '*** IF ANGLES CHANGE, REFRESHES AXES
    IF OPH <> PHI THEN GOSUB B

       
        IYOP = SY - MY * (XOLD * RM1 - YOLD * RM2 + ZOLD * RM3)
        IXOP = SX + MX * (XOLD * RM4 + YOLD * RM5)
        IYNP = SY - MY * (XNEW * RM1 - YNEW * RM2 + ZNEW * RM3)
        IXNP = SX + MX * (XNEW * RM4 + YNEW * RM5)
    
        LINE (IXOP, IYOP)-(IXNP, IYNP), 14
        XOLD = XNEW: YOLD = YNEW: ZOLD = ZNEW
      
       GOTO A


B:  ' **** ROTATING COORDINATE AXES
        
        CLS
        IXOP = SX + MAX * RM4: IYOP = SY - MAY * RM1
        IXNP = SX - MAX * RM4: IYNP = SY + MAY * RM1
        LINE (IXOP, IYOP)-(IXNP, IYNP), 13
       
        IXOP = SX + MAX * RM5: IYOP = SY + MAY * RM2
        IXNP = SX - MAX * RM5: IYNP = SY - MAY * RM2
        LINE (IXOP, IYOP)-(IXNP, IYNP), 11
       
        IXOP = SX: IYOP = SY - MAY * RM3
        IXNP = SX: IYNP = SY + MAY * RM3
        LINE (IXOP, IYOP)-(IXNP, IYNP), 9
        
        LOCATE 1, 5: PRINT "INCREASE/DECREASE THETA, <I>/<D>"
        LOCATE 1, 45: PRINT "HIGHER/LOWER ABOVE (X,Y), <H>/<L>"
        LOCATE 2, 20: PRINT " CLEAR SCREEN, <C>; NEW INITIAL CONDITIONS, <N>"
        LOCATE 3, 25: PRINT "<P>/<M> TO `PLUS'/`MINUS' R; R ="; R
        IF R > 0 THEN LOCATE 5, 10: PRINT "      KEEP TRYING NEW INTIAL CONDITIONS - WHAT'S CHANGED?"
        IF R > 20 THEN RETURN
        LOCATE 5, 10: PRINT "   TRY MANY NEW INITIAL CONDITIONS, AND **WAIT** FOR THE DYNAMICS"
        IF R = 17 THEN LOCATE 6, 10: PRINT "                   *** WAIT A WHILE! ***"
        IF R = 17 THEN SOUND 600, 3
        IF R = 18 THEN LOCATE 7, 10: PRINT "            DO YOU NOTICE *THREE* ATTRACTORS ??"
        IF R = 18 THEN SOUND 900, 4
          
   RETURN



