   CLS
   '8-2B
    RANDOMIZE TIMER
    SCREEN 9
    N = 3
    DIM X(N), OX(N), Y(N), K(4, N)
    DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14
   
    LOCATE 10, 10: PRINT "        THE POINCARE MAP ONTO THE PLANE Z = Z0 = R-1"
    LOCATE 12, 10: PRINT "THE MAPPED POINTS ARE SHOWN IN THE (X,Y) COORDINATES ON THIS PLANE"
    LOCATE 14, 10: INPUT "     SELECT R >1 (E.G., INCREASE FROM R = 20);  R ="; R
    CLS
    GOTO AB

AA:  LOCATE 4, 30: INPUT "NEW VALUE OF R = (E.G., 15)"; R
AB: Z0 = R - 1   '** THE PLANE THAT CONTAINS TWO FIXED POINTS
   
    M = 70 / SQR(R)   '*** GRAPHICS MAGNIFICATION
    IF R > 100 THEN M = 50 / SQR(R)
    MX = M: MY = .731 * M
    CT = 0
    DT = .05
   
    '*** INITIAL CONDITIONS NEAR THE PLANE Z0
    X(1) = SQR(B * (R - 1)) + 50 * (1 - 2 * RND)
    X(2) = SQR(B * (R - 1)) + 50 * (1 - 2 * RND)
    X(3) = R + 5 * (1 - 2 * RND)

A:  CLS
    LOCATE 1, 15: PRINT "        THE POINCARE MAP ON THE PLANE Z = R-1"
    LOCATE 2, 15: PRINT "    CLEAR, <C>;    NEW R, <R>;    NEW INITIAL STATE, <N>"
   
    PT = 0 '*** TO COUNT THE NUMBER OF POINTS IN THE POINCARE MAP - ACTIVATE BELOW
    GOSUB B: ' COORDINATE SYSTEM
   LOCATE 4, 15: PRINT "    TRY A NUMBER OF INITIAL CONDITIONS, AND WAIT"
  

C: ' ******** FOURTH ORDER RUNGE-KUTTA ROUTINE *************
     A$ = INKEY$
     R0 = R
     IF A$ = "I" THEN R = R + 1
     IF A$ = "D" THEN R = R - 1
     IF R < 1 THEN SOUND 600, 3
     IF R < 1 THEN R = 1
   
     IF R <> R0 THEN GOTO AB
     IF A$ = "X" THEN END
     IF A$ = "C" THEN GOTO A   '*** REFRESHES SCREEN
     IF A$ = "R" THEN GOTO AA
     IF A$ = "N" THEN GOTO AB'** NEW INITIAL CONDITIONS
     CT = CT + 1

     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     SG = 10: B = 8 / 3
  
     '***** LORENZ EQUATIONS ****
     F(1) = SG * (Y(2) - Y(1))
     F(2) = R * Y(1) - Y(2) - Y(3) * Y(1)
     F(3) = -B * Y(3) + Y(1) * Y(2)
     '*********************************
     K(J, 1) = DT * F(1)
     K(J, 2) = DT * F(2)
     K(J, 3) = DT * F(3)
    
     ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS
E:   T = T + .5 * DT
    FOR I = 1 TO N
     Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D

F:  FOR I = 1 TO N
     Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D

G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D
             
H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I

  '*************** POINCARE MAP ONTO THE PLANE Z = Z0 *************
    IF (X(3) - Z0) * (OX(3) - Z0) > 0 THEN GOTO I
    IF X(3) > OX(3) THEN GOTO I: ' MAPS DOWNWARD CROSSINGS OF Z0 PLANE
    PSET (320 + MX * X(1), 200 - MY * X(2)), YEL
    IF R < 27 THEN CIRCLE (320 + MX * X(1), 200 - MY * X(2)), 1, YEL
    XY = SQR(B * (R - 1))
    CIRCLE (320 + MX * XY, 200 - MY * XY), 3, LBL  '*** FIXED POINTS
    CIRCLE (320 - MX * XY, 200 + MY * XY), 3, LBL

    PT = PT + 1  '******** NUMBER OF MAPPED POINTS
 '  LOCATE 7, 5: PRINT "NUMBER OF POINTS ="; PT     '** SLOWS DOWN ITERATION
I:    '*********************************************
    FOR I = 1 TO N: OX(I) = X(I): NEXT I

    GOTO C
   
B:  '********** GRAPHICS COORDINATE SYSTEM ****************
     LINE (20, 200)-(620, 200), DBL
     LINE (320, 20)-(320, 380), DBL
     LOCATE 3, 60: PRINT "R ="; R
     LOCATE 3, 10: PRINT " FOR *UNIT* INCREASE/DECREASE R = <I>/<D>"
     IF R = 22 THEN LOCATE 5, 30: PRINT "   *** WAIT! ***"
     IF R = 22 THEN SOUND 500, 2
     IF R = 23 THEN LOCATE 5, 30: PRINT "*** WAIT LONGER ***"
     IF R = 23 THEN SOUND 800, 3
     IF R = 24 THEN LOCATE 5, 25: PRINT " *** WHAT DO YOU THINK ??? ***"
     IF R = 24 THEN SOUND 900, 3
     IF R >= 25 THEN LOCATE 5, 20: PRINT "** THE TWO FIXED POINTS ARE NOW UNSTABLE **"
     IF R = 25 THEN SOUND 1000, 4
      RETURN


