'8-4A
SCREEN 9
RANDOMIZE TIMER
LOCATE 5
PRINT "               THE DYNAMICS OF AN EXCITABLE COLONY OF ANTS"
PRINT ""
PRINT "      THE ANTS ARE ACTIVATED TO MOVE RANDOMLY ON A LATTICE ONLY WHEN,"
PRINT " AT TIME T, THEY ARE EXCITED ABOVE AN ACTIVATION THRESHOLD, E(I,T) > ATH "
PRINT "       "
PRINT "      THE CHANGE IN THEIR EXCITATION DEPENDS ON THE SUM OF THE EXCITED STATES"
PRINT "             OF THEIR 8 NEIGHBORS, AND THEIR OWN EXCITED STATE. "
PRINT ""
PRINT "   ALSO SPONTANEOUS EXCITATIONS OF MAGNITUDE MSE OCCUR, WITH A PROBABILITY PSE"
PRINT ""
PRINT "  THEIR EXCITATION CHANGES ACCORDING TO E(I,T+1) = TANH( G * NSE(I,E(J,T)) "
PRINT ""
PRINT "     WHERE NSE(I,E(J,T)) IS THE 'NEIGHBORHOOD' SUM OF THE EXITATIONS OF ALL ANTS"
PRINT "          IN THE 9-CELLS CENTERED ABOUT ANT I, AND G<<1 IS THE DECAY CONSTANT "
K: IF INKEY$ = "" THEN GOTO K
CLS
LOCATE 10
PRINT "       THIS EXPLORATION INVOLVES THE STUDY OF THE CHANGE IN AN ANT COLONY"
PRINT "             DYNAMICS AS THE DENSITY WITHIN THE COLONY IS INCREASED"

NS = 10  '********NUMBER OF LATTICE SITES ON A SIDE
PRINT ""
PRINT "          PRESENTLY THE ANTS MOVE ON A "; NS; "-BY-"; NS; " LATTICE "
LOCATE 16
 PRINT "        SELECT A LOW DENSITY OF ANTS (E.G., 0.05) = NUMBER ANTS/"; (NS * NS); ""
 PRINT ""
 PRINT "              THIS DENSITY CAN BE INCREASED/DECREASED BY <I>/,D>"
 PRINT ""
 INPUT "                        INITIAL DENSITY ="; DEN
 DEN = INT(NS * NS * DEN) / (NS * NS)
  
   '******* THE DYNAMIC CHARACTERISTICS OF ALL ANTS
ATH = 1E-15         '*** ACTIVATION THRESHOLD        
PSE = .01           '*** PROBABILITY OF SPONTANEOUS EXCITATION
MSE = .01           '*** MAGNITUDE OF SPONTANEOUS EXCITATION
G = .05             '*** EXCITATION/DECAY COUPLING CONSTANT


GX = 200: GY = 50  '*** GRAPHICS CENTER
MX = 15: MY = 10   '*** LATTICE GRAPHICS
 
DIM X(NS ^ 2), Y(NS ^ 2), E(NS ^ 2), OE(NS ^ 2), NE(NS ^ 2)'*** LOCATION AND EXCITATION STATE

DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14

AAA: NA = (DEN * NS * NS)'*** NUMBER OF ANTS

 TCT = 0 ' THE TOTAL COUNT OF TIME FOR PERCENTAGE OF TIME THAT ACTIVATION > 50%
 TA50 = 0' THE TIME THAT ACTIVITY IS > 50%

'***** NON-OVERLAPPING DISTRIBUTION


    FOR I = 1 TO NA
A5: X(I) = INT(NS * RND + 1)
    Y(I) = INT(NS * RND + 1)
    IF I = 1 THEN GOTO A6
   
    FOR J = 1 TO I - 1
    IF ABS(X(I) - X(J)) + ABS(Y(I) - Y(J)) = O THEN GOTO A5
    NEXT J
 
A6: NEXT I

'*** INITIALLY ALL ANTS ARE INACTIVE
  
  FOR K = 1 TO NA
    E(K) = 0  '*** CAN CONTRAST WITH E(K)=RND
  NEXT K
            
AA: CLS
                  
  CT = 0 ' THE COUNT FROM ONE LINE OF DISPLAY

  LOCATE 2, 3: PRINT "  DYNAMICS AND PERCENTAGE ACTIVITY FOR DENSITY ="; DEN; "; WHAT ELSE?"
  PRINT "                TO INCREASE/DECREASE THE DENSITY, <I>/<D>"
 
  FOR I = 1 TO NS
  FOR J = 1 TO NS
  CIRCLE (GX + MX * I, GY + MY * J), 1, RED  '*** LATTICE
  NEXT J
  NEXT I

  '**** PERCENTAGE ACTIVITY GRAPH
   LINE (50, 320)-(50, 210), DBL
   LINE (50, 320)-(610, 320), DBL
   FOR I = 0 TO 4
   LINE (50, 320 - I * 25)-(45, 320 - I * 25), DBL
   NEXT I
   FOR I = 1 TO 11
   LINE (50 + I * 50, 320)-(50 + I * 50, 325), DBL
   NEXT I
   LINE (50, 220)-(610, 220), RED      '** 100%
         
A: '************************* DYNAMIC LOOP
    A$ = INKEY$
   CT = CT + 1
   TCT = TCT + 1'**** THE TOTAL TIME RUN

   IF CT > 560 THEN GOTO AA
     IF A$ = "X" THEN END
     IF A$ = "I" THEN DEN = DEN + .05
     IF A$ = "D" THEN DEN = DEN - .05
      DEN = INT(NS * NS * DEN) / (NS * NS)
     IF A$ <> "" THEN GOTO AAA
   

'***
   ACT = 0   '*** THE ACTIVITY COUNT = NUMBER OF ACTIVE ANTS
 
 FOR I = 1 TO NA
  CIRCLE (GX + MX * X(I), GY + MY * Y(I)), 4, DBL    '*** INACTIVE COLOR
  IF E(I) <= ATH THEN E(I) = 0
  'IF CT > 50 AND E(I) = 0 THEN BEEP '****** CAN EXPLORE THE EFFECT OF ATH
 
  IF E(I) <= ATH THEN GOTO A1
 
   ACT = ACT + 1
   OX = X(I)   '*** STORING INITIAL POSITION
   OY = Y(I)

 '********    RANDOM ACTIVITY DYNAMICS  *********
 
   X(I) = X(I) + INT(3 * RND - 1)
   IF X(I) < 1 THEN X(I) = OX  '** CONFINED TO LATTICE
   IF X(I) > NS THEN X(I) = OX
  
   Y(I) = Y(I) + INT(3 * RND - 1)
   IF Y(I) < 1 THEN Y(I) = OX  '** CONFINED TO LATTICE
   IF Y(I) > NS THEN Y(I) = OX

 '***** ANT I DOES NOT MOVE ONTO LOCATION OF ANY OTHER ANT
 FOR J = 1 TO NA
    IF J = I THEN GOTO A2
    IF ABS(X(I) - X(J)) + ABS(Y(I) - Y(J)) = 0 THEN X(I) = OX  '** POSITION RETURNED
    IF ABS(X(I) - X(J)) + ABS(Y(I) - Y(J)) = 0 THEN Y(I) = OY
A2: NEXT J
 
    CIRCLE (GX + MX * OX, GY + MY * OY), 4, 0 '*** ERASES OLD POSITION
    CIRCLE (GX + MX * X(I), GY + MY * Y(I)), 4, YEL  '*** NEW POSITION
           
A1: NEXT I

  
'*** SPONTANEOUS EXCITATION ONLY IF E(I) < ATH
     
    FOR I = 1 TO NA
      IF E(I) > ATH THEN GOTO A4
       IF (RND + PSE) >= 1 THEN E(I) = MSE
    
A4: NEXT I
  
   '**** THE PERCENTAGE-ACTIVITY GRAPH
    IF CT = 1 THEN GOTO A3
    LINE (50 + CT, 320 - 100 * ACT / NA)-(50 + (CT - 1), 320 - 100 * OACT / NA), GRN'**
  
   '*** TA50 = TOTAL TIME THAT ACTIVE ANTS > 50%
    IF ACT / NA > .5 THEN TA50 = TA50 + 1
    F50 = TA50 / TCT  '*** FRACTION OF TIME
    LOCATE 5, 5: PRINT INT(100 * F50); "%"   'PERCENTAGE OF TIME WITH PERCENTAGE ACTIVATION >50%

A3: OTE = TE
    OACT = ACT
   
   FOR I = 1 TO NA
   
    NSE = 0  '*** NEIGHBORHOOD EXCITATION SUM FOR ANT I
   FOR K = 1 TO NA
    IF ABS(X(I) - X(K)) > 1 THEN GOTO AB
    IF ABS(Y(I) - Y(K)) > 1 THEN GOTO AB
    '** ADDING UP THE EXCITATION OF ALL ANTS IN THE 9 LOCATIONS CONTAINING I
    NSE = E(K) + NSE
AB: NEXT K
              
    '*** NEW EXCITATION STATE, T+1, FOR ANT I
    EC = 2.718282
    X = G * NSE
    '*** E(I, T+1) = TANH(G*NSE(I,T))
    NE(I) = (EC ^ X - EC ^ (-X)) / (EC ^ X + EC ^ (-X)) '*** NEW E(I)

    NEXT I
   
  FOR I = 1 TO NA
    E(I) = NE(I)    '*** NEW E(I,T+1)
  NEXT I
  
  GOTO A


