'8-4B
SCREEN 9
RANDOMIZE TIMER
LOCATE 5
PRINT "   EXPLORING THE DYNAMICS OF COLONIES OF DIFFERENT SPECIES OF EXCITABLE ANTS"
PRINT ""
PRINT "      THE ANTS ARE ACTIVATED TO MOVE RANDOMLY ON A LATTICE ONLY WHEN,"
PRINT " AT TIME T, THEY ARE EXCITED ABOVE AN ACTIVATION THRESHOLD, E(I,T) > ATH "
PRINT "       "
PRINT "      THE CHANGE IN THEIR EXCITATION DEPENDS ON THE SUM OF THE EXCITED STATES"
PRINT "             OF THEIR 8 NEIGHBORS, AND THEIR OWN EXCITED STATE. "
PRINT ""
PRINT "   ALSO SPONTANEOUS EXCITATIONS OCCUR WITH A PROBABILITY PSE, BY AN AMOUNT MSE"
PRINT ""
PRINT "  THEIR EXCITATION DECREASES ACCORDING TO E(I,T+1) = TANH( G* NBH(I,E(J,T)) "
PRINT ""
PRINT "   WHERE NBH(I,E(J,T)) IS THE SUM OF THE EXITATIONS OF ALL ANTS"
PRINT "                IN THE 9-CELLS CENTERED ABOUT ANT I "
K: IF INKEY$ = "" THEN GOTO K
CLS
LOCATE 10
PRINT "       THIS EXPLORATION INVOLVES THE STUDY OF THE CHANGE IN THE ANT COLONY"
PRINT "             DYNAMICS AS THE DENSITY WITHIN THE COLONY IS INCREASED"

NS = 13      '*** NUMBER OF LATTICE SITES ON A SIDE (MODIFY TO NS <= 18)
PRINT ""
PRINT "     PRESENTLY THE ANTS MOVE ON A "; NS; "-BY-"; NS; " LATTICE (MODIFY THIS)"
DIM X(NS ^ 2), Y(NS ^ 2), E(NS ^ 2), OE(NS ^ 2), NE(NS ^ 2)'*** LOCATION AND EXCITATION STATE

LOCATE 16
 PRINT "        SELECT A LOW DENSITY OF ANTS (E.G., 0.1) = NUMBER ANTS/"; NS; "*"; NS; ""
 INPUT "                                DENSITY ="; DEN
CLS
LOCATE 5
'**** ENDOGENOUS DYNAMIC CHARACTERISTICS OF EACH ANT
PRINT ""
PRINT "             NOW YOU CAN EXPLORE THE DYNAMICS OF DIFFERENT 'SPECIES' OF ANTS"
PRINT ""
PRINT "    THESE 'SPECIES' ARE DEFINED BY THEIR ENDOGENOUS DYNAMIC CHARACTERISTICS"
PRINT ""
NS: PRINT "                 TO BUILD YOUR OWN SPECIES, <> !!!"
PRINT ""
INPUT "            FOR A 'STANDARD' SPECIES (ENTER YOUR OWN LATER), <S>"; SS$
IF SS$ = "S" THEN GOTO S
CLS
LOCATE 5
INPUT "      SELECT THE ACTIVATION THRESHOLD (E.G., => 1E-5), ATH ="; ATH
PRINT ""
INPUT "      SELECT THE PROBABILITY OF SPONTANEOUS EXCITATION (E.G., <= .1), PSE ="; PSE
PRINT ""
INPUT "      SELECT THE MAGNITUDE OF SPONTANEOUS EXCITATION (E.G., <= 0.1), MSE ="; MSE
PRINT ""
INPUT "      SELECT THE EXCITATION DECAY CONSTANT (E.G., <= .5), G ="; G

GOTO SS: '*** NEW SELECTED SPECIES CHARACTERISTICS

S: ' *** A STANDARDIZED SPECIES (MODIFY THIS FOR SELECTIVE REPETITIONS)
ATH = 1E-16        '*** ACTIVATION THRESHOLD         
PSE = .01          '*** PROBABILITY OF SPONTANEOUS EXCITATION
MSE = .01          '*** MAGNITUDE OF SPONTANEOUS EXCITATION
G = .05            '*** EXCITATION DECAY AND COUPLING CONSTANT (WHY?)

SS: '**** SELECTED SPECIES

GX = 200: GY = 40 - 2 * (NS - 12)'*** GRAPHICS CENTER
MX = 15: MY = 10   '*** LATTICE GRAPHICS
 


DBL = 9: GRN = 10: LBL = 11: RED = 12: MAG = 13: YEL = 14

AAA: NA = (DEN * NS * NS)'*** NUMBER OF ANTS
 
'***** NON-OVERLAPPING DISTRIBUTION

    FOR I = 1 TO NA
A5: X(I) = INT(NS * RND + 1)
    Y(I) = INT(NS * RND + 1)
    IF I = 1 THEN GOTO A6
   
    FOR J = 1 TO I - 1
    IF ABS(X(I) - X(J)) + ABS(Y(I) - Y(J)) = O THEN GOTO A5
    NEXT J
 
A6: NEXT I

'*** INITIALLY ALL ANTS ARE INACTIVE
  
  FOR K = 1 TO NA
    E(K) = 0
  NEXT K
            
AA: CLS
                  
  CT = 0
  DDEN = INT(1000 * DEN) / 1000 '**** DISPLAYS THREE PLACES
  PRINT " DENSITY ="; DDEN; "; FOR NEW SPECIES, <N>; TO INCREASE/DECREASE DENSITY, <I>/<D>"
  PRINT " SPECIES: ATH ="; ATH; ", PSE ="; PSE; ",  MSE ="; MSE; ", DECAY CONSTANT, G ="; G; ""
  FOR I = 1 TO NS
  FOR J = 1 TO NS
  CIRCLE (GX + MX * I, GY + MY * J), 1, RED  '*** LATTICE
  NEXT J
  NEXT I
  
  '**** PERCENTAGE ACTIVITY GRAPH
   LINE (50, 320)-(50, 210), DBL
   LINE (50, 320)-(610, 320), DBL
   FOR I = 0 TO 4
   LINE (50, 320 - I * 25)-(45, 320 - I * 25), DBL
   LINE (50, 220)-(610, 220), RED      '** 100%
   NEXT I

A: '************************* DYNAMIC LOOP
    A$ = INKEY$
   CT = CT + 1
   IF CT > 570 THEN GOTO AA
     IF A$ = "X" THEN END
     IF A$ = "I" THEN DEN = DEN + .025
     IF A$ = "D" THEN DEN = DEN - .025
     IF A$ = "N" THEN CLS
     IF A$ = "N" THEN GOTO NS  '**** NEW SPECIES SELECTION
     IF A$ <> "" THEN GOTO AAA
   

'***
   ACT = 0   '*** THE ACTIVITY COUNT = NUMBER OF ACTIVE ANTS

 FOR I = 1 TO NA
  CIRCLE (GX + MX * X(I), GY + MY * Y(I)), 4, DBL    '*** INACTIVE ANT COLOR
 
  IF E(I) <= ATH THEN GOTO A1
 
   ACT = ACT + 1
   OX = X(I)   '*** STORING INITIAL POSITION
   OY = Y(I)

 '********    RANDOM ACTIVITY DYNAMICS  *********
 
   X(I) = X(I) + INT(3 * RND - 1)
   IF X(I) < 1 THEN X(I) = OX  '** CONFINED TO LATTICE
   IF X(I) > NS THEN X(I) = OX
  
   Y(I) = Y(I) + INT(3 * RND - 1)
   IF Y(I) < 1 THEN Y(I) = OX  '** CONFINED TO LATTICE
   IF Y(I) > NS THEN Y(I) = OX

 '***** ANT I DOES NOT MOVE ONTO LOCATION OF ANY OTHER ANT
 FOR J = 1 TO NA
    IF J = I THEN GOTO A2
    IF ABS(X(I) - X(J)) + ABS(Y(I) - Y(J)) = 0 THEN X(I) = OX  '**RETURNED
    IF ABS(X(I) - X(J)) + ABS(Y(I) - Y(J)) = 0 THEN Y(I) = OY
A2: NEXT J
 
    CIRCLE (GX + MX * OX, GY + MY * OY), 4, 0 '*** ERASES OLD POSITION
    CIRCLE (GX + MX * X(I), GY + MY * Y(I)), 4, YEL  '*** NEW POSITION
    
A1: NEXT I

  
'*** SPONTANEOUS EXCITATION ONLY IF E(I) < ATH
     
    FOR I = 1 TO NA
      IF E(I) > ATH THEN GOTO A4
       IF (RND + PSE) >= 1 THEN E(I) = MSE
    
A4: NEXT I
  
   '**** THE PERCENTAGE-ACTIVITY GRAPH
    TE = 0
    FOR K = 1 TO NA
    TE = TE + E(K)
    NEXT K
    IF CT = 1 THEN GOTO A3
    LINE (50 + CT, 320 - 100 * ACT / NA)-(50 + (CT - 1), 320 - 100 * OACT / NA), GRN'**
   
A3: OTE = TE
    OACT = ACT
   
   FOR I = 1 TO NA
   
    NES = 0  '*** NEIGHBORHOOD EXCITATION SUM FOR ANT I
   FOR K = 1 TO NA
    IF ABS(X(I) - X(K)) > 1 THEN GOTO AB
    IF ABS(Y(I) - Y(K)) > 1 THEN GOTO AB
    NES = E(K) + NES
AB: NEXT K
              
    '*** NEW EXCITATION STATE, T+1, FOR ANT I
    EC = 2.718282
    X = G * NES
    '*** E(I, T+1) = TANH(G*NES(I,T))
    NE(I) = (EC ^ X - EC ^ (-X)) / (EC ^ X + EC ^ (-X)) '*** NEW E(I)
    NEXT I
   
  FOR I = 1 TO NA
    E(I) = NE(I)    '*** NEW E(I)
  NEXT I
  
  GOTO A


