   CLS
   'C4.BAS
    SCREEN 9
    PRINT " FOURTH-ORDER RUNGE-KUTTA INTEGRATION FOR N FIRST-ORDER ODE"
    N = 2: ' THE NUMBER OF FIRST-ORDER EQUATIONS
    DIM X(N), OX(N), Y(N), K(4, N)
    DBL = 9: GRN = 10: LBL = 11: RED = 12
        MAG = 13: YEL = 14: '***** COLOR SELECTIONS
    PRINT ""
    INPUT "          GRAPHICS MAGNIFICATION = (E.G., 50)"; M
    MX = M: MY = .731 * M: ' Y-MAGNIFICATION ADJUSTED FOR GRAPHICS
    PRINT ""
    INPUT "                THE SIZE OF THE TIME STEP (E.G., .01)"; DT
    PRINT ""
    PRINT " ***  THE INITIAL CONDITIONS"
    FOR I = 1 TO N
    PRINT ""
    PRINT "    X("; I; ")  =  (E.G., 3)",
    INPUT X(I)
    NEXT I

A:  CLS
    LOCATE 1, 15: PRINT "THIS DEMONSTRATION IS A REVERSING SPIRAL FLOW"
    GOSUB B: ' GRAPHICS FOR THE COORDINATE SYSTEM OF THE PHASE SPACE

C: ' ******** FOURTH ORDER RUNGE-KUTTA ROUTINE *************
     CT = CT + 1: 'ITERATION COUNT; SEE HOW IT IS USED BELOW

     '*** Y(I) IS A DUMMY VARIABLE WHICH IS CHANGED AT EACH OF THE FOUR ORDERS
     FOR I = 1 TO N
     Y(I) = X(I)
     NEXT I
    
     J = 0: ' INDEX FOR THE FOUR ORDERS
D:   J = J + 1
     '**** THE N DYNAMIC FUNCTIONS ****
     F(1) = (Y(2) * Y(2) + Y(1) * Y(1) - 1) * Y(2) - .2 * Y(1)
     F(2) = -(Y(2) * Y(2) + Y(1) * Y(1) - 1) * Y(1) - .2 * Y(2)
     '*********************************
     K(J, 1) = DT * F(1)
     K(J, 2) = DT * F(2)
     ON J GOTO E, F, G, H: ' ** THE FOUR ITERATIONS

E:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(1, I) / 2
    NEXT I
    GOTO D

F:  FOR I = 1 TO N
    Y(I) = X(I) + K(2, I) / 2
    NEXT I
    GOTO D

G:  T = T + .5 * DT
    FOR I = 1 TO N
    Y(I) = X(I) + K(3, I)
    NEXT I
    GOTO D

H:  FOR I = 1 TO N
    X(I) = X(I) + K(1, I) / 6 + K(2, I) / 3 + K(3, I) / 3 + K(4, I) / 6
    NEXT I

    IF CT = 1 THEN GOTO I: 'IMPORTANT: GRAPHIC LINE STARTS AFTER SECOND ITERATION

    LINE (320 + MX * X(1), 200 - MY * X(2))-(320 + MX * OX(1), 200 - MY * OX(2)), LBL

I:  FOR I = 1 TO N: OX(I) = X(I): NEXT I: ' SAVES THE LAST X(I) FOR GRAPHIC LINE
   
    '********** GENERALLY OMIT THESE ********************
    LOCATE 1, 1: PRINT "CT="; CT: ' CAN BE OMITTED
    IF CT > 3000 THEN END  '******** LIMITS THE NUMBER OF ITERATIONS
    '*****************************************************

    GOTO C

B:   REM:********** GRAPHICS COORDINATE SYSTEM ****************
     NX = 300 / MX: NY = 190 / MY: ' NUMBER OF UNIT INTERVALS
     LINE (20, 200)-(620, 200), DBL
     LINE (320, 20)-(320, 380), DBL
     FOR I = 1 TO NX
     FOR J = 1 TO 4
     PSET (320 + MX * I, 200 - J), DBL
     PSET (320 - MX * I, 200 - J), DBL
     NEXT J
     NEXT I
     FOR J = 1 TO 4
     PSET (320, 400 - J), DBL
     NEXT J
     FOR I = 1 TO NY
     FOR J = 1 TO 3
     PSET (320 + J, 200 - MY * I), DBL
     PSET (320 + J, 200 + MY * I), DBL
     NEXT J
     NEXT I
     RETURN



